"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnPickerDialog = void 0;
const react_1 = __importStar(require("react"));
const use_dialog_1 = require("@borvik/use-dialog");
const contexts_1 = require("../table/contexts");
const useDerivedState_1 = require("../../utils/useDerivedState");
const immutable_1 = require("../../utils/immutable");
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const orderBy_1 = require("./orderBy");
const groupBy_1 = require("./groupBy");
const isset_1 = require("../../utils/isset");
const ColumnPickerDialog = function ColumnPickerDialog() {
    var _a, _b, _c, _d, _e, _f, _g;
    const dialogEl = (0, react_1.useRef)(null);
    const { actualColumns, columnOrder, setColumnConfig, classNames, labels, groupBy, canGroupBy, doNotUseHTML5Dialog, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [visible, setVisible] = (0, useDerivedState_1.useDeepDerivedState)((prev) => {
        var _a;
        let newVisible = {};
        for (let col of actualColumns) {
            newVisible[col.key] = (_a = prev === null || prev === void 0 ? void 0 : prev[col.key]) !== null && _a !== void 0 ? _a : col.isVisible;
        }
        return newVisible;
    }, [actualColumns]);
    const [dialogOrder, setOrder] = (0, react_1.useState)(columnOrder);
    const [dialogGroup, setGroup] = (0, react_1.useState)(groupBy);
    const [sourceDroppable, setSourceDroppable] = (0, react_1.useState)(null);
    const groupedColumns = dialogGroup.map(g => actualColumns.find(c => g.column === c.name)).filter(isset_1.isset);
    const fixedColumns = actualColumns.filter(c => !!c.fixed);
    const fixedLeftColumns = fixedColumns.filter(c => c.fixed === 'left' && (c.sortable || c.canToggleVisibility));
    const fixedRightColumns = fixedColumns.filter(c => c.fixed === 'right' && (c.sortable || c.canToggleVisibility));
    const [sortedColumns] = (0, useDerivedState_1.useDeepDerivedState)(() => {
        let cols = actualColumns.filter(c => !c.fixed).map(c => {
            let idx = dialogOrder.findIndex(k => k === c.key);
            if (idx < 0)
                return c;
            return (0, immutable_1.update)(c, { sortIndex: { $set: idx } });
        });
        cols.sort((a, b) => a.sortIndex - b.sortIndex);
        return cols;
    }, [dialogOrder]);
    let btnCloseClass;
    let btnApplyClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.dialogCloseButton)) {
        btnCloseClass = `${(_a = classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) !== null && _a !== void 0 ? _a : ''} ${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.dialogCloseButton) !== null && _b !== void 0 ? _b : ''}`.trim();
    }
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.dialogApplyButton)) {
        btnApplyClass = `${(_c = classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) !== null && _c !== void 0 ? _c : ''} ${(_d = classNames === null || classNames === void 0 ? void 0 : classNames.dialogApplyButton) !== null && _d !== void 0 ? _d : ''}`.trim();
    }
    function toggleSort(index) {
        var _a;
        let sort = dialogGroup[index];
        let col = actualColumns.find(c => c.name === sort.column);
        let newSort = sort.direction === null
            ? { column: sort.column, direction: (_a = col === null || col === void 0 ? void 0 : col.defaultSortDir) !== null && _a !== void 0 ? _a : 'asc' }
            : Object.assign(Object.assign({}, sort), { direction: sort.direction === 'asc' ? 'desc' : 'asc' });
        setGroup((0, immutable_1.update)(dialogGroup, { [index]: { $set: newSort } }));
    }
    return react_1.default.createElement(use_dialog_1.Dialog, { doNotUseHTML5Dialog: doNotUseHTML5Dialog, className: 'setting-dialog', dialogRef: dialogEl, onSubmit: (close) => __awaiter(this, void 0, void 0, function* () {
            setColumnConfig({
                visibility: visible,
                columnOrder: dialogOrder,
                groupBy: dialogGroup,
            });
            close();
        }) },
        react_1.default.createElement(use_dialog_1.DialogHeader, null, (_e = labels === null || labels === void 0 ? void 0 : labels.columns) !== null && _e !== void 0 ? _e : 'Columns'),
        react_1.default.createElement(use_dialog_1.DialogBody, { className: 'order-by-dialog-body' },
            react_1.default.createElement(react_beautiful_dnd_1.DragDropContext, { onDragStart: (start) => {
                    let column = actualColumns.find(c => c.key === start.draggableId);
                    setSourceDroppable({
                        column,
                        sourceList: start.source.droppableId,
                    });
                }, onDragEnd: (result) => {
                    setSourceDroppable(null);
                    const { destination, source, reason } = result;
                    if (reason === 'CANCEL' || !destination)
                        return;
                    if (destination.droppableId === source.droppableId && destination.index === source.index)
                        return;
                    if (destination.droppableId === source.droppableId) {
                        if (destination.droppableId === 'order-by-main') {
                            // drag/drop within main list
                            let keys = sortedColumns.map(c => c.key);
                            let movingItem = keys[source.index];
                            keys.splice(source.index, 1);
                            keys.splice(destination.index, 0, movingItem);
                            setOrder(keys);
                        }
                        else if (destination.droppableId === 'group-by') {
                            // drag/drop within group list
                            let movingItem = dialogGroup[source.index];
                            setGroup((0, immutable_1.update)(dialogGroup, {
                                $splice: [
                                    [source.index, 1],
                                    [destination.index, 0, movingItem]
                                ]
                            }));
                        }
                    }
                    else if (source.droppableId === 'group-by' && destination.droppableId === 'order-by-main') {
                        // moving from group-by to main column list
                        // remove from origin, add to main (if not fixed)
                        setGroup((0, immutable_1.update)(dialogGroup, { $splice: [[source.index, 1]] }));
                    }
                    else if (destination.droppableId === 'group-by') {
                        // moving from A column list to group-by
                        let col = null;
                        if (source.droppableId === 'order-by-fixed-left') {
                            col = fixedLeftColumns[source.index];
                        }
                        else if (source.droppableId === 'order-by-fixed-right') {
                            col = fixedRightColumns[source.index];
                        }
                        else if (source.droppableId === 'order-by-main') {
                            col = sortedColumns[source.index];
                        }
                        if (!col) {
                            console.warn('Unable to find source column!!!');
                            return;
                        }
                        // determine default sort
                        let newSort = { column: col.name, direction: col.defaultSortDir };
                        setGroup((0, immutable_1.update)(dialogGroup, { $splice: [[destination.index, 0, newSort]] }));
                    }
                } },
                react_1.default.createElement("div", { className: 'ungrouped-columns' },
                    react_1.default.createElement(orderBy_1.OrderByList, { containerId: 'order-by-fixed-left', sortedColumns: fixedLeftColumns, visibleColumns: visible, setVisibleColumns: setVisible, dragColumn: sourceDroppable, isDropDisabled: true, isDragDisabled: !canGroupBy, currentGroupBy: dialogGroup }),
                    react_1.default.createElement(orderBy_1.OrderByList, { containerId: 'order-by-main', sortedColumns: sortedColumns, visibleColumns: visible, setVisibleColumns: setVisible, dragColumn: sourceDroppable, currentGroupBy: dialogGroup, isDragDisabled: false, isDropDisabled: sourceDroppable !== null &&
                            sourceDroppable.sourceList !== 'group-by' &&
                            sourceDroppable.sourceList !== 'order-by-main' }),
                    react_1.default.createElement(orderBy_1.OrderByList, { containerId: 'order-by-fixed-right', sortedColumns: fixedRightColumns, visibleColumns: visible, setVisibleColumns: setVisible, dragColumn: sourceDroppable, isDropDisabled: true, isDragDisabled: !canGroupBy, currentGroupBy: dialogGroup })),
                canGroupBy && react_1.default.createElement(groupBy_1.GroupByList, { groupedColumns: groupedColumns, groupedDirections: dialogGroup, dragColumn: sourceDroppable, toggleSort: toggleSort, isDragDisabled: false }))),
        react_1.default.createElement(use_dialog_1.DialogFooter, null,
            react_1.default.createElement("button", { type: 'button', className: btnCloseClass, onClick: () => {
                    var _a;
                    (_a = dialogEl.current) === null || _a === void 0 ? void 0 : _a.close();
                } }, (_f = labels === null || labels === void 0 ? void 0 : labels.close) !== null && _f !== void 0 ? _f : 'Close'),
            react_1.default.createElement("button", { type: 'submit', className: btnApplyClass }, (_g = labels === null || labels === void 0 ? void 0 : labels.apply) !== null && _g !== void 0 ? _g : 'Apply')));
};
exports.ColumnPickerDialog = ColumnPickerDialog;
