"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnPickerButton = void 0;
const react_1 = __importStar(require("react"));
const use_dialog_1 = require("@borvik/use-dialog");
const contexts_1 = require("../table/contexts");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faCog_1 = require("@fortawesome/free-solid-svg-icons/faCog");
const dialog_1 = require("./dialog");
const ColumnPickerButton = function ColumnPickerButton() {
    var _a, _b, _c, _d;
    const { dialog, showDialog } = (0, use_dialog_1.useDialog)(react_1.default.createElement(dialog_1.ColumnPickerDialog, null));
    const { actualColumns, setColumnConfig, onShowColumnPicker, classNames, labels, components, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    function onButtonClick(e) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (onShowColumnPicker) {
                    yield onShowColumnPicker(actualColumns, setColumnConfig, e.currentTarget);
                }
                else {
                    yield showDialog();
                }
            }
            catch (err) {
                console.error(err);
            }
        });
    }
    let btnSettingsClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonSettings)) {
        btnSettingsClass = `${(_a = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _a !== void 0 ? _a : ''} ${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonSettings) !== null && _b !== void 0 ? _b : ''}`.trim();
    }
    const CustomButton = (_c = components === null || components === void 0 ? void 0 : components.Buttons) === null || _c === void 0 ? void 0 : _c.ColumnPicker;
    return react_1.default.createElement(react_1.default.Fragment, null,
        dialog,
        !!CustomButton && react_1.default.createElement(CustomButton, { onClick: onButtonClick }),
        !CustomButton && react_1.default.createElement("button", { type: 'button', title: (_d = labels === null || labels === void 0 ? void 0 : labels.settings) !== null && _d !== void 0 ? _d : 'Settings', className: btnSettingsClass, onClick: onButtonClick },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCog_1.faCog })));
};
exports.ColumnPickerButton = ColumnPickerButton;
