"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OrderByList = void 0;
const react_1 = __importStar(require("react"));
const react_beautiful_dnd_1 = require("react-beautiful-dnd");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faGripVertical_1 = require("@fortawesome/free-solid-svg-icons/faGripVertical");
const faEye_1 = require("@fortawesome/free-solid-svg-icons/faEye");
const faEyeSlash_1 = require("@fortawesome/free-solid-svg-icons/faEyeSlash");
const contexts_1 = require("../table/contexts");
const OrderByList = function OrderByList({ currentGroupBy, dragColumn, containerId, isDropDisabled, sortedColumns, visibleColumns, setVisibleColumns, isDragDisabled }) {
    return (react_1.default.createElement(react_beautiful_dnd_1.Droppable, { droppableId: containerId, isDropDisabled: isDropDisabled }, (provided, snapshot) => {
        let classNames = ['config-column-list'];
        if (!isDropDisabled && !!dragColumn) {
            classNames.push('is-droppable');
        }
        if (snapshot.isDraggingOver) {
            classNames.push('is-dragging-over');
        }
        return (react_1.default.createElement("div", Object.assign({ ref: provided.innerRef, className: classNames.join(' ') }, provided.droppableProps),
            sortedColumns.map((col, index) => {
                const isVisible = visibleColumns[col.key];
                return react_1.default.createElement(ColumnEl, { key: col.key, colIndex: index, col: col, isVisible: isVisible, isDragDisabled: isDragDisabled, toggleVisibility: () => setVisibleColumns(prev => (Object.assign(Object.assign({}, prev), { [col.key]: !prev[col.key] }))), currentGroupBy: currentGroupBy, dragColumn: dragColumn });
            }),
            (dragColumn === null || dragColumn === void 0 ? void 0 : dragColumn.sourceList) === 'group-by' && react_1.default.createElement("span", { style: { display: 'none' } }, provided.placeholder),
            (dragColumn === null || dragColumn === void 0 ? void 0 : dragColumn.sourceList) !== 'group-by' && react_1.default.createElement(react_1.default.Fragment, null, provided.placeholder)));
    }));
};
exports.OrderByList = OrderByList;
function getDragStyle(style, snapshot, dragColumn) {
    if ((dragColumn === null || dragColumn === void 0 ? void 0 : dragColumn.sourceList) === 'group-by')
        return {};
    return style;
}
const ColumnEl = function ColumnEl({ dragColumn, col, colIndex, isVisible, toggleVisibility, isDragDisabled, currentGroupBy }) {
    const { canReorderColumns } = (0, react_1.useContext)(contexts_1.ColumnContext);
    let classNames = ['config-column'];
    let group = currentGroupBy.find(g => g.column === col.name);
    if (group)
        classNames.push('grouped');
    return react_1.default.createElement(react_beautiful_dnd_1.Draggable, { draggableId: col.key, index: colIndex, isDragDisabled: !canReorderColumns || isDragDisabled }, (provided, snapshot) => (react_1.default.createElement("div", Object.assign({ className: classNames.join(' ') }, provided.draggableProps, (!canReorderColumns ? provided.dragHandleProps : {}), { ref: provided.innerRef, style: getDragStyle(provided.draggableProps.style, snapshot, dragColumn) }),
        canReorderColumns && react_1.default.createElement(react_1.default.Fragment, null,
            isDragDisabled && react_1.default.createElement("div", { className: 'column-drag-placeholder' }),
            !isDragDisabled && react_1.default.createElement("div", Object.assign({ className: 'column-drag' }, provided.dragHandleProps),
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faGripVertical_1.faGripVertical, fixedWidth: true }))),
        react_1.default.createElement("span", { className: 'column-header' }, col.header),
        !!col.canToggleVisibility && react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("button", { className: 'visibility-toggle', type: 'button', title: 'Toggle Visibility', onClick: () => toggleVisibility() },
                isVisible && react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faEye_1.faEye, fixedWidth: true }),
                !isVisible && react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faEyeSlash_1.faEyeSlash, fixedWidth: true }))))));
};
