"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Item = void 0;
const react_1 = __importStar(require("react"));
const cx_1 = require("../utils/cx");
const styles_1 = require("../utils/styles");
const noop = () => { };
class Item extends react_1.Component {
    constructor(props) {
        super(props);
        this.handleClick = (e) => {
            this.isDisabled
                ? e.stopPropagation()
                : this.props.onClick({
                    event: this.props.nativeEvent,
                    props: Object.assign(Object.assign({}, this.props.propsFromTrigger), this.props.data)
                });
        };
        this.handleEnter = (e) => {
            if (e.key !== 'Enter')
                return;
            this.isDisabled
                ? e.stopPropagation()
                : this.props.onClick({
                    event: this.props.nativeEvent,
                    props: Object.assign(Object.assign({}, this.props.propsFromTrigger), this.props.data)
                });
        };
        const { disabled, nativeEvent, propsFromTrigger, data } = this.props;
        this.isDisabled =
            typeof disabled === 'function'
                ? disabled({
                    event: nativeEvent,
                    props: Object.assign(Object.assign({}, propsFromTrigger), data)
                })
                : disabled;
    }
    render() {
        const { className, style, children } = this.props;
        const cssClasses = (0, cx_1.cx)(styles_1.styles.item, className, {
            [`${styles_1.styles.itemDisabled}`]: this.isDisabled
        });
        return (react_1.default.createElement("div", { className: cssClasses, style: style, onClick: this.handleClick, onKeyDown: this.handleEnter, role: "presentation", tabIndex: 0 },
            react_1.default.createElement("div", { className: styles_1.styles.itemContent }, children)));
    }
}
Item.defaultProps = {
    disabled: false,
    onClick: noop
};
exports.Item = Item;
