import { Component, ReactNode, SyntheticEvent, ReactElement } from 'react';
import { MenuId, StyleProps } from '../types';
export interface MenuProviderProps extends StyleProps {
    /**
     * Unique id to identify the menu. Use to Trigger the corresponding menu
     */
    id: MenuId;
    /**
     * Any valid node that can be rendered
     */
    children: ReactNode;
    /**
     * Any valid node that can be rendered or a function returning a valid react node
     */
    component: ReactNode | ((args?: any) => ReactNode);
    /**
     * Render props
     */
    render?: (args?: any) => ReactNode;
    /**
     * Any react event
     * `onClick`, `onContextMenu`, ...
     */
    event: string;
    /**
     * Store children ref
     * `default: true`
     */
    storeRef: boolean;
    /**
     * Any valid object, data are passed to the menu item callback
     */
    data?: object;
}
export declare class MenuProvider extends Component<MenuProviderProps> {
    static defaultProps: {
        component: string;
        event: string;
        storeRef: boolean;
    };
    childrenRefs: HTMLElement[];
    handleEvent: (e: SyntheticEvent) => void;
    onKey: (e: React.KeyboardEvent<HTMLInputElement>) => void;
    setChildRef: (ref: HTMLElement) => number | true;
    getChildren(): (string | number | ReactElement<any, string | import("react").JSXElementConstructor<any>> | Iterable<ReactNode>)[] | null | undefined;
    render(): ReactNode;
}
