"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuProvider = void 0;
const react_1 = require("react");
const actions_1 = require("../utils/actions");
const eventManager_1 = require("../utils/eventManager");
class MenuProvider extends react_1.Component {
    constructor() {
        super(...arguments);
        this.childrenRefs = [];
        this.handleEvent = (e) => {
            e.preventDefault();
            e.stopPropagation();
            eventManager_1.eventManager.emit((0, actions_1.DISPLAY_MENU)(this.props.id), e.nativeEvent, Object.assign({ ref: this.childrenRefs.length === 1
                    ? this.childrenRefs[0]
                    : this.childrenRefs }, this.props.data));
        };
        this.onKey = (e) => {
            if (e.key === 'Enter' || e.key === ' ' || e.key === 'Spacebar') {
                console.log('Display Menu via keypress');
                eventManager_1.eventManager.emit((0, actions_1.DISPLAY_MENU)(this.props.id), e.nativeEvent, Object.assign({ ref: this.childrenRefs.length === 1
                        ? this.childrenRefs[0]
                        : this.childrenRefs }, this.props.data));
            }
        };
        this.setChildRef = (ref) => ref === null || this.childrenRefs.push(ref);
    }
    getChildren() {
        // remove all the props specific to the provider
        const _a = this.props, { id, component, event, children, className, style, storeRef, data } = _a, rest = __rest(_a, ["id", "component", "event", "children", "className", "style", "storeRef", "data"]);
        // reset refs
        this.childrenRefs = [];
        return react_1.Children.map(children, child => (0, react_1.isValidElement)(child)
            ? (0, react_1.cloneElement)(child, Object.assign(Object.assign({}, rest), (storeRef ? { ref: this.setChildRef } : {})))
            : child);
    }
    render() {
        const { id, component, render, event, className, style } = this.props;
        const attributes = {
            [event]: this.handleEvent,
            className,
            style,
            id,
            tabIndex: 0,
            onKeyDown: this.onKey,
            'data-noautofocus': true,
        };
        if (typeof render === 'function') {
            return render(Object.assign(Object.assign({}, attributes), { children: this.getChildren() }));
        }
        return (0, react_1.createElement)(component, attributes, this.getChildren());
    }
}
MenuProvider.defaultProps = {
    component: 'div',
    event: 'onContextMenu',
    storeRef: true
};
exports.MenuProvider = MenuProvider;
