"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Portal = void 0;
const react_1 = require("react");
const react_dom_1 = require("react-dom");
exports.Portal = (0, react_1.memo)(function Portal({ children, renderTarget }) {
    const containerRef = (0, react_1.useRef)(null);
    const [_, toggleRerender] = (0, react_1.useState)(false);
    (0, react_1.useEffect)(() => {
        let getElement = renderTarget;
        let el = null;
        if (!!getElement) {
            el = getElement();
        }
        let createdEl = false;
        if (!el && typeof document !== 'undefined') {
            el = document.createElement('div');
            document.body.appendChild(el);
            createdEl = true;
        }
        containerRef.current = el;
        toggleRerender(p => !p);
        return () => {
            if (!!createdEl && !!el) {
                el.remove();
            }
            containerRef.current = null;
            toggleRerender(p => !p);
        };
    }, [renderTarget]);
    if (!containerRef.current) {
        return null;
    }
    return (0, react_dom_1.createPortal)(children, containerRef.current);
});
