"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Submenu = void 0;
const react_1 = __importStar(require("react"));
const cx_1 = require("../utils/cx");
const cloneItem_1 = require("./cloneItem");
const styles_1 = require("../utils/styles");
class Submenu extends react_1.Component {
    constructor() {
        super(...arguments);
        this.state = {
            left: '100%',
            top: 0,
            bottom: 'initial'
        };
        this.setRef = (ref) => {
            this.menu = ref;
        };
    }
    componentDidMount() {
        const { innerWidth, innerHeight } = window;
        const rect = this.menu.getBoundingClientRect();
        const style = {};
        if (rect.right < innerWidth) {
            style.left = '100%';
            style.right = undefined;
        }
        else {
            style.right = '100%';
            style.left = undefined;
        }
        if (rect.bottom > innerHeight) {
            style.bottom = 0;
            style.top = 'initial';
        }
        else {
            style.bottom = 'initial';
            style.top = 0;
        }
        this.setState(style);
    }
    handleClick(e) {
        e.stopPropagation();
    }
    render() {
        const { arrow, disabled, className, style, label, nativeEvent, children, propsFromTrigger } = this.props;
        const cssClasses = (0, cx_1.cx)(styles_1.styles.item, className, {
            [`${styles_1.styles.itemDisabled}`]: typeof disabled === 'function'
                ? disabled({
                    event: nativeEvent,
                    props: Object.assign({}, propsFromTrigger)
                })
                : disabled
        });
        const submenuStyle = Object.assign(Object.assign({}, style), this.state);
        return (react_1.default.createElement("div", { className: cssClasses, role: "presentation" },
            react_1.default.createElement("div", { className: styles_1.styles.itemContent, onClick: this.handleClick },
                label,
                react_1.default.createElement("span", { className: styles_1.styles.submenuArrow }, arrow)),
            react_1.default.createElement("div", { className: styles_1.styles.submenu, ref: this.setRef, style: submenuStyle }, (0, cloneItem_1.cloneItem)(children, {
                propsFromTrigger,
                nativeEvent: nativeEvent
            }))));
    }
}
Submenu.defaultProps = {
    arrow: '▶',
    disabled: false,
    nativeEvent: {}
};
exports.Submenu = Submenu;
