"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cx = void 0;
function cx(...classNames) {
    return classNames.reduce((results, cls) => {
        if (!cls)
            return results;
        if (typeof cls === 'string') {
            results.push(cls);
        }
        else {
            let keys = Object.keys(cls);
            for (let k of keys) {
                if (cls[k])
                    results.push(k);
            }
        }
        return results;
    }, [])
        .join(' ');
}
exports.cx = cx;
