"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuickFilterItem = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("../../table/types");
const contexts_1 = require("../../table/contexts");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faTimesCircle_1 = require("@fortawesome/free-solid-svg-icons/faTimesCircle");
const value_1 = require("./value");
const context_1 = require("./context");
const get_1 = __importDefault(require("lodash/get"));
const QuickFilterItem = function QuickFilterItem({ filter, column, path, parentCollectionCount }) {
    var _a, _b, _c, _d, _e, _f;
    const { filterSettings } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const { removeAtPath } = (0, react_1.useContext)(context_1.QuickBarContext);
    let metaLabel = undefined;
    if (typeof ((_a = column.filter) === null || _a === void 0 ? void 0 : _a.metaToDisplay) === 'string') {
        if (!column.filter.metaToDisplay) {
            // empty string - use root
            if (filter.meta)
                metaLabel = filter.meta;
        }
        else {
            let metaDisplay = (0, get_1.default)(filter.meta, column.filter.metaToDisplay);
            if (metaDisplay)
                metaLabel = metaDisplay;
        }
    }
    return react_1.default.createElement("span", { className: 'quick-filter-field-container' },
        parentCollectionCount > 1 && react_1.default.createElement("button", { onClick: () => removeAtPath(path), type: 'button', className: 'quick-filter-item-remove-btn filter-btn' },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimesCircle_1.faTimesCircle })),
        react_1.default.createElement("span", { className: 'quick-filter-field' },
            react_1.default.createElement("span", { className: 'quick-filter-field-name' }, (_d = (_c = (_b = column === null || column === void 0 ? void 0 : column.filter) === null || _b === void 0 ? void 0 : _b.label) !== null && _c !== void 0 ? _c : column === null || column === void 0 ? void 0 : column.header) !== null && _d !== void 0 ? _d : react_1.default.createElement("i", null, "No column"),
                !!metaLabel && react_1.default.createElement(react_1.default.Fragment, null,
                    "[",
                    react_1.default.createElement("i", null, metaLabel),
                    "]")),
            react_1.default.createElement("span", { className: 'quick-filter-field-operator' }, (_f = (_e = filterSettings === null || filterSettings === void 0 ? void 0 : filterSettings.quickOperatorLabels) === null || _e === void 0 ? void 0 : _e[filter.operator]) !== null && _f !== void 0 ? _f : types_1.QuickOperatorLabels[filter.operator]),
            react_1.default.createElement("span", { className: 'quick-filter-field-value' },
                react_1.default.createElement(value_1.QuickFilterValue, { column: column, filter: filter, path: path }))));
};
exports.QuickFilterItem = QuickFilterItem;
