"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuickFilterGroup = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("../../table/types");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faTimesCircle_1 = require("@fortawesome/free-solid-svg-icons/faTimesCircle");
const field_1 = require("./field");
const contexts_1 = require("../../table/contexts");
const context_1 = require("./context");
const QuickFilterGroup = function QuickFilterGroup({ topLevel, value, path }) {
    const { filterColumns } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const { removeAtPath } = (0, react_1.useContext)(context_1.QuickBarContext);
    const prefix = '(', suffix = ')';
    const currentPath = path !== null && path !== void 0 ? path : [];
    let groupContents = [];
    for (let idx = 0; idx < value.filters.length; idx++) {
        let filter = value.filters[idx];
        let newPath = [...currentPath, idx];
        if (groupContents.length)
            groupContents.push(` ${value.groupOperator} `);
        if ((0, types_1.isFilterGroup)(filter))
            groupContents.push(react_1.default.createElement(QuickFilterGroup, { key: newPath.join(','), topLevel: false, value: filter, path: newPath }));
        else {
            let column = filterColumns.find(c => { var _a; return ((_a = c.filter) === null || _a === void 0 ? void 0 : _a.filterKey) === filter.column; });
            if (column) {
                groupContents.push(react_1.default.createElement(field_1.QuickFilterItem, { path: newPath, key: newPath.join(','), column: column, filter: filter, parentCollectionCount: value.filters.length }));
            }
        }
    }
    return react_1.default.createElement("span", { className: 'quick-filter-group-container' },
        react_1.default.createElement("button", { onClick: () => removeAtPath(currentPath), type: 'button', className: 'quick-filter-item-remove-btn filter-btn' },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimesCircle_1.faTimesCircle })),
        react_1.default.createElement("span", { className: 'quick-filter-group' },
            react_1.default.createElement("span", { className: 'quick-filter-group-prefix' }, prefix),
            react_1.default.createElement("span", { className: 'quick-filter-group-contents' }, groupContents),
            react_1.default.createElement("span", { className: 'quick-filter-group-suffix' }, suffix)));
};
exports.QuickFilterGroup = QuickFilterGroup;
