"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterBar = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../../table/contexts");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faFilter_1 = require("@fortawesome/free-solid-svg-icons/faFilter");
const use_dialog_1 = require("@borvik/use-dialog");
const dialog_1 = require("../dialog");
const group_1 = require("./group");
const context_1 = require("./context");
const use_querystate_1 = require("@borvik/use-querystate");
const immutable_1 = require("../../../utils/immutable");
const get_1 = __importDefault(require("lodash/get"));
// Test url: http://localhost:3000/?filter=(id:1),(id:1;op:nul),(or:(id:3,4;op:bet),(id:5,6,7;op:any)),(and:(id:9))
const FilterBar = function FilterBar() {
    const { dialog, showDialog } = (0, use_dialog_1.useDialog)(react_1.default.createElement(dialog_1.FilterDialog, null));
    const { filter, setFilter, setPagination, onShowFilterEditor } = (0, react_1.useContext)(contexts_1.ColumnContext);
    if (!filter.filters.length)
        return react_1.default.createElement(react_1.default.Fragment, null);
    function applyFilter(filterState) {
        (0, use_querystate_1.batchedQSUpdate)(() => {
            setFilter(filterState);
            setPagination(prev => (Object.assign(Object.assign({}, prev), { page: 1 })));
        });
    }
    function onButtonClick(e) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (onShowFilterEditor) {
                    yield onShowFilterEditor(filter, applyFilter, e.currentTarget);
                }
                else {
                    yield showDialog();
                }
            }
            catch (err) {
                console.error(err);
            }
        });
    }
    function removeAtPath(path, valueIdx) {
        // perform immutable `update`
        let newFilter = null;
        let getPath = [];
        if (typeof valueIdx !== 'number') {
            // field/group removal
            let $spec = { filters: { $set: [] } };
            if (path.length) {
                let fieldGroupIdx = path.pop();
                $spec = { filters: { $splice: [[fieldGroupIdx, 1]] } };
                getPath.unshift('filters');
                if (path.length) {
                    for (let i = path.length - 1; i >= 0; i--) {
                        let idx = path[i];
                        $spec = { filters: { [idx]: $spec } };
                        getPath.unshift('filters', idx);
                    }
                }
            }
            // newFilter will be an immutable copy of filter
            // from here we can make mutable changes to newFilter
            // before sending to the setFilter function
            newFilter = (0, immutable_1.update)(filter, $spec);
        }
        else {
            // value removal from multi-value field
            let fieldGroupIdx = path.pop();
            let $spec = { filters: { [fieldGroupIdx]: { value: { $splice: [[valueIdx, 1]] } } } };
            getPath.unshift('filters', fieldGroupIdx, 'value');
            if (path.length) {
                for (let i = path.length - 1; i >= 0; i--) {
                    let idx = path[i];
                    $spec = { filters: { [idx]: $spec } };
                    getPath.unshift('filters', idx);
                }
            }
            newFilter = (0, immutable_1.update)(filter, $spec);
        }
        // check if we cleared all filters
        while (getPath.length) {
            // check filters at path
            let arr = (0, get_1.default)(newFilter, getPath);
            if (!arr.length) {
                getPath.pop();
                if (!getPath.length) {
                    newFilter = { groupOperator: 'and', filters: [] };
                }
                else {
                    newFilter = removeDeepArray(newFilter, getPath);
                }
            }
            // pop two off getPath
            getPath.pop();
            getPath.pop();
        }
        if (!newFilter) {
            newFilter = { groupOperator: 'and', filters: [] };
        }
        (0, use_querystate_1.batchedQSUpdate)(() => {
            setFilter(newFilter);
            setPagination(prev => (Object.assign(Object.assign({}, prev), { page: 1 })));
        });
    }
    return react_1.default.createElement("div", { className: 'filter-bar' },
        dialog,
        react_1.default.createElement("button", { type: 'button', onClick: onButtonClick },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFilter_1.faFilter })),
        react_1.default.createElement("div", { className: "quick-filter" },
            react_1.default.createElement(context_1.QuickBarContext.Provider, { value: { removeAtPath } },
                react_1.default.createElement(group_1.QuickFilterGroup, { topLevel: true, value: filter }))));
};
exports.FilterBar = FilterBar;
/**
 * Utility function to remove the specified element from the
 * array it is in. Path should be a lodash compatible path
 * to the specific element to remove, and the next to last
 * element in the path is the array to remove it from.
 */
function removeDeepArray(obj, path) {
    // keep path immutable to avoid changing the param reference
    let workingPath = [...path];
    let idxToRemove = workingPath.pop();
    let $spec = { $splice: [[idxToRemove, 1]] };
    for (let i = workingPath.length - 1; i >= 0; i--) {
        let idx = workingPath[i];
        $spec = { [idx]: $spec };
    }
    return (0, immutable_1.update)(obj, $spec);
}
