"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.QuickFilterValue = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("../editor/value-editors/types");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faTimesCircle_1 = require("@fortawesome/free-solid-svg-icons/faTimesCircle");
const context_1 = require("./context");
const QuickFilterValue = function QuickFilterValue(props) {
    switch (props.filter.operator) {
        case 'nul':
        case 'nnul':
            return react_1.default.createElement(react_1.default.Fragment, null); // Nulls don't have values
        case 'bet':
        case 'nbet':
            return react_1.default.createElement(DoubleValue, Object.assign({}, props));
        case 'any':
        case 'none':
            return react_1.default.createElement(MultiValue, Object.assign({}, props));
        default:
            return react_1.default.createElement(SingleValue, Object.assign({}, props));
    }
};
exports.QuickFilterValue = QuickFilterValue;
const DoubleValue = function DoubleValue(props) {
    return react_1.default.createElement(react_1.default.Fragment, null,
        '[',
        react_1.default.createElement(SingleValue, Object.assign({}, props, { valuePath: 0 })),
        react_1.default.createElement("span", { className: 'double-value-separator' }, "and"),
        react_1.default.createElement(SingleValue, Object.assign({}, props, { valuePath: 1 })),
        ']');
};
const MultiValue = function MultiValue(props) {
    var _a;
    const { removeAtPath } = (0, react_1.useContext)(context_1.QuickBarContext);
    let values = (_a = props.filter.value) !== null && _a !== void 0 ? _a : [];
    let valueKeyBase = JSON.stringify(values);
    return react_1.default.createElement(react_1.default.Fragment, null,
        "[",
        values.map((_value, index, arr) => (react_1.default.createElement("span", { className: 'multi-value-value', key: valueKeyBase + '_' + index },
            arr.length > 1 && react_1.default.createElement("button", { onClick: () => removeAtPath(props.path, index), type: 'button', className: 'quick-filter-value-remove-btn' },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimesCircle_1.faTimesCircle })),
            react_1.default.createElement("span", null,
                react_1.default.createElement(SingleValue, Object.assign({}, props, { valuePath: index })))))),
        "]");
};
const SingleValue = function SingleValue({ column, filter, valuePath }) {
    let value = (0, types_1.getValue)(filter.value, valuePath !== null && valuePath !== void 0 ? valuePath : null);
    switch (column.filter.type) {
        case 'boolean':
            return react_1.default.createElement(react_1.default.Fragment, null, value ? 'true' : 'false');
        case 'custom':
            return react_1.default.createElement(react_1.default.Fragment, null, column.filter.toDisplay(value));
        default:
            return react_1.default.createElement(react_1.default.Fragment, null, value);
    }
};
