"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterDialog = void 0;
const react_1 = __importStar(require("react"));
const use_dialog_1 = require("@borvik/use-dialog");
const contexts_1 = require("../table/contexts");
const use_querystate_1 = require("@borvik/use-querystate");
const editor_1 = require("./editor");
const FilterDialog = function FilterDialog() {
    var _a, _b, _c, _d, _e, _f, _g;
    const dialogEl = (0, react_1.useRef)(null);
    const { filter, setFilter, setPagination, classNames, labels, doNotUseHTML5Dialog } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [filterState, setFilterState] = (0, react_1.useState)(filter);
    let btnCloseClass;
    let btnApplyClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.dialogCloseButton)) {
        btnCloseClass = `${(_a = classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) !== null && _a !== void 0 ? _a : ''} ${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.dialogCloseButton) !== null && _b !== void 0 ? _b : ''}`.trim();
    }
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.dialogApplyButton)) {
        btnApplyClass = `${(_c = classNames === null || classNames === void 0 ? void 0 : classNames.dialogButton) !== null && _c !== void 0 ? _c : ''} ${(_d = classNames === null || classNames === void 0 ? void 0 : classNames.dialogApplyButton) !== null && _d !== void 0 ? _d : ''}`.trim();
    }
    return react_1.default.createElement(use_dialog_1.Dialog, { doNotUseHTML5Dialog: doNotUseHTML5Dialog, className: 'filter-dialog', dialogRef: dialogEl, onSubmit: (close) => __awaiter(this, void 0, void 0, function* () {
            (0, use_querystate_1.batchedQSUpdate)(() => {
                setFilter(filterState);
                setPagination(prev => (Object.assign(Object.assign({}, prev), { page: 1 })));
            });
            close();
        }) },
        react_1.default.createElement(use_dialog_1.DialogHeader, null, (_e = labels === null || labels === void 0 ? void 0 : labels.filter) !== null && _e !== void 0 ? _e : 'Filter'),
        react_1.default.createElement(use_dialog_1.DialogBody, null,
            react_1.default.createElement(editor_1.FilterEditor, { value: filterState, onChange: setFilterState })),
        react_1.default.createElement(use_dialog_1.DialogFooter, null,
            react_1.default.createElement("button", { type: 'button', className: btnCloseClass, onClick: () => { var _a; (_a = dialogEl.current) === null || _a === void 0 ? void 0 : _a.close(); } }, (_f = labels === null || labels === void 0 ? void 0 : labels.close) !== null && _f !== void 0 ? _f : 'Close'),
            react_1.default.createElement("button", { type: 'submit', className: btnApplyClass }, (_g = labels === null || labels === void 0 ? void 0 : labels.apply) !== null && _g !== void 0 ? _g : 'Apply')));
};
exports.FilterDialog = FilterDialog;
