"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterFieldEditor = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("../../table/types");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faTimesCircle_1 = require("@fortawesome/free-solid-svg-icons/faTimesCircle");
const context_menu_1 = require("../../context-menu");
const contexts_1 = require("../../table/contexts");
const useDerivedState_1 = require("../../../utils/useDerivedState");
const closest_1 = require("../../../utils/closest");
const value_editors_1 = require("./value-editors");
const helpers_1 = require("../helpers");
const get_1 = __importDefault(require("lodash/get"));
const FilterFieldEditor = function FilterFieldEditor({ canLimitConditions, filter, path, index, setState, groupValue }) {
    var _a, _b, _c, _d, _e, _f;
    const itemEl = (0, react_1.useRef)(null);
    const { filterColumns, filterSettings } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ column, sortedColumns }] = (0, useDerivedState_1.useDerivedState)(() => {
        return {
            column: filterColumns.find(c => { var _a; return ((_a = c.filter) === null || _a === void 0 ? void 0 : _a.filterKey) === filter.column; }),
            sortedColumns: [...filterColumns]
                .filter(c => {
                if (canLimitConditions) {
                    return !!c.filter && !groupValue.filters.find((f) => {
                        if ((0, types_1.isFilterGroup)(f))
                            return false;
                        return c.filter.filterKey === f.column;
                    });
                }
                return !!c.filter;
            })
                .sort((a, b) => {
                var _a, _b, _c, _d, _e, _f;
                let aName = (_c = (_b = (_a = a.filter) === null || _a === void 0 ? void 0 : _a.label) !== null && _b !== void 0 ? _b : a.header) !== null && _c !== void 0 ? _c : '';
                let bName = (_f = (_e = (_d = b.filter) === null || _d === void 0 ? void 0 : _d.label) !== null && _e !== void 0 ? _e : b.header) !== null && _f !== void 0 ? _f : '';
                if (aName > bName)
                    return 1;
                if (aName < bName)
                    return -1;
                return 0;
            })
        };
    }, [filterColumns, filter, canLimitConditions, groupValue]);
    const currentPath = [...(path !== null && path !== void 0 ? path : []), index];
    const currentPathAsString = currentPath.join(',');
    let availableOperators = (0, helpers_1.getAvailableOperators)(column === null || column === void 0 ? void 0 : column.filter);
    /**
     * Unlike the group - PATH is the _group_ path, all operations must include self index
     */
    function remove() {
        setState(path, { filters: { $splice: [[index, 1]] } });
    }
    function setColumn(col) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let defaultOp = (0, helpers_1.getDefaultOperator)(col.filter);
            let defaultValue = (0, helpers_1.getDefaultValue)(defaultOp, col.filter);
            let columnMeta = undefined;
            if (typeof ((_a = col.filter) === null || _a === void 0 ? void 0 : _a.onChosen) === 'function') {
                let chosenResult = yield col.filter.onChosen({ op: defaultOp, value: defaultValue, column: col, isEdit: false });
                if (chosenResult) {
                    if (typeof chosenResult.op !== 'undefined')
                        defaultOp = chosenResult.op;
                    if (typeof chosenResult.value !== 'undefined')
                        defaultValue = chosenResult.value;
                    if (typeof chosenResult.metadata !== 'undefined')
                        columnMeta = chosenResult.metadata;
                }
            }
            setState(path, {
                filters: {
                    [index]: {
                        column: { $set: col.filter.filterKey },
                        operator: { $set: defaultOp },
                        value: { $set: defaultValue },
                        meta: { $set: typeof columnMeta !== 'undefined' ? columnMeta : undefined },
                    }
                }
            });
        });
    }
    function setMetadata() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof ((_a = column === null || column === void 0 ? void 0 : column.filter) === null || _a === void 0 ? void 0 : _a.onChosen) !== 'function') {
                return;
            }
            let chosenResult = yield column.filter.onChosen({ op: filter.operator, value: filter.value, column, metadata: filter.meta, isEdit: true });
            if (!chosenResult) {
                return;
            }
            let filterSpec = {};
            if (typeof chosenResult.op !== 'undefined')
                filterSpec.operator = { $set: chosenResult.op };
            if (typeof chosenResult.value !== 'undefined')
                filterSpec.value = { $set: chosenResult.value };
            if (typeof chosenResult.metadata !== 'undefined')
                filterSpec.meta = { $set: chosenResult.metadata };
            if (!Object.keys(filterSpec))
                return;
            setState(path, {
                filters: {
                    [index]: filterSpec
                }
            });
        });
    }
    function setOperator(op) {
        var _a, _b, _c, _d;
        let filterSpec = { operator: { $set: op } };
        let arrayType = (0, helpers_1.valueShouldBeArray)(op);
        let isArray = Array.isArray(filter.value);
        if (arrayType === helpers_1.ValueCount.SingleValue && isArray) {
            if (filter.value.length)
                filterSpec.value = { $set: filter.value[0] };
            else
                filterSpec.value = { $set: null };
        }
        else if (arrayType === helpers_1.ValueCount.NoValue) {
            filterSpec.value = { $set: null };
        }
        else if (arrayType !== helpers_1.ValueCount.SingleValue) {
            if (arrayType === helpers_1.ValueCount.DualValue) {
                if (!isArray) {
                    if (typeof filter.value === 'undefined' || filter.value === null)
                        filterSpec.value = { $set: [null, null] };
                    else
                        filterSpec.value = { $set: [filter.value, null] };
                }
                else {
                    if (filter.value.length !== 2) {
                        filterSpec.value = { $set: [(_b = (_a = filter.value) === null || _a === void 0 ? void 0 : _a[0]) !== null && _b !== void 0 ? _b : null, (_d = (_c = filter.value) === null || _c === void 0 ? void 0 : _c[1]) !== null && _d !== void 0 ? _d : null] };
                    }
                }
            }
            else if (arrayType === helpers_1.ValueCount.ManyValue && !isArray) {
                if (typeof filter.value === 'undefined' || filter.value === null)
                    filterSpec.value = { $set: [null] };
                else
                    filterSpec.value = { $set: [filter.value] };
            }
        }
        setState(path, {
            filters: {
                [index]: filterSpec
            }
        });
    }
    let metaLabel = undefined;
    if (column) {
        if (typeof ((_a = column.filter) === null || _a === void 0 ? void 0 : _a.metaToDisplay) === 'string') {
            if (!column.filter.metaToDisplay) {
                // empty string - use root
                if (filter.meta)
                    metaLabel = filter.meta;
            }
            else {
                let display = (0, get_1.default)(filter.meta, column.filter.metaToDisplay);
                if (display)
                    metaLabel = display;
            }
        }
    }
    return react_1.default.createElement("div", { ref: itemEl, className: 'filter-item-editor' },
        react_1.default.createElement(context_menu_1.MenuProvider, { event: 'onClick', id: `filter_column_menu_${currentPathAsString}`, className: `filter-column` }, (_d = (_c = (_b = column === null || column === void 0 ? void 0 : column.filter) === null || _b === void 0 ? void 0 : _b.label) !== null && _c !== void 0 ? _c : column === null || column === void 0 ? void 0 : column.header) !== null && _d !== void 0 ? _d : react_1.default.createElement("span", { className: "no-column" }, "Choose Column")),
        react_1.default.createElement(context_menu_1.Menu, { id: `filter_column_menu_${currentPathAsString}`, renderTarget: () => (0, closest_1.closest)(itemEl.current, 'dialog, .dialog'), position: 'bottom-left', animation: 'zoom' }, sortedColumns.map(c => { var _a, _b, _c; return react_1.default.createElement(context_menu_1.Item, { key: c.key, onClick: () => setColumn(c) }, (_c = (_b = (_a = c === null || c === void 0 ? void 0 : c.filter) === null || _a === void 0 ? void 0 : _a.label) !== null && _b !== void 0 ? _b : c === null || c === void 0 ? void 0 : c.header) !== null && _c !== void 0 ? _c : ''); })),
        !!metaLabel && react_1.default.createElement("span", { className: 'filter_column_meta_label', onClick: () => setMetadata() }, metaLabel),
        react_1.default.createElement(context_menu_1.MenuProvider, { event: 'onClick', id: `filter_operator_menu_${currentPathAsString}`, className: `filter-operator` }, (_f = (_e = filterSettings === null || filterSettings === void 0 ? void 0 : filterSettings.operatorLabels) === null || _e === void 0 ? void 0 : _e[filter.operator]) !== null && _f !== void 0 ? _f : types_1.OperatorLabels[filter.operator]),
        !!availableOperators.length && react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(context_menu_1.Menu, { id: `filter_operator_menu_${currentPathAsString}`, renderTarget: () => (0, closest_1.closest)(itemEl.current, 'dialog, .dialog'), position: 'bottom-left', animation: 'zoom' }, availableOperators.map(op => {
                var _a, _b;
                return (react_1.default.createElement(context_menu_1.Item, { key: op, onClick: () => setOperator(op) }, (_b = (_a = filterSettings === null || filterSettings === void 0 ? void 0 : filterSettings.operatorLabels) === null || _a === void 0 ? void 0 : _a[op]) !== null && _b !== void 0 ? _b : types_1.OperatorLabels[op]));
            }))),
        react_1.default.createElement("div", { className: 'filter-value' },
            react_1.default.createElement(value_editors_1.FilterValueEditor, { column: column, filter: filter, path: path, index: index, setState: setState })),
        react_1.default.createElement("button", { type: 'button', "data-noautofocus": true, className: 'filter-item-remove-btn filter-btn', onClick: () => remove() },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimesCircle_1.faTimesCircle })));
};
exports.FilterFieldEditor = FilterFieldEditor;
