"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanEditor = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("./types");
const isset_1 = require("../../../../utils/isset");
const setValue_1 = require("./setValue");
const BooleanEditor = function BooleanEditor({ setState, path, index, filter, valuePath }) {
    var _a;
    const [editing, setEditing] = (0, react_1.useState)(false);
    const inputRef = (0, react_1.useRef)(null);
    const enableEditing = (0, react_1.useCallback)(() => setEditing(true), [setEditing]);
    const disableEditing = (0, react_1.useCallback)(() => {
        let currentValue = (0, types_1.getValue)(filter.value, valuePath);
        if (!(0, isset_1.isset)(currentValue)) {
            (0, setValue_1.setValue)({ setState, path, index, valuePath, value: false, filter });
        }
        setEditing(false);
    }, [setEditing, filter, valuePath, path, index, setState]);
    (0, react_1.useEffect)(() => {
        var _a;
        if (!editing)
            return;
        function handleClickOutside(e) {
            var _a;
            if (inputRef.current && inputRef.current !== e.target && !((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.contains(e.target))) {
                disableEditing();
            }
        }
        (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        document.addEventListener('mousedown', handleClickOutside);
        return () => {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, [editing, disableEditing]);
    function onChange(e) {
        let checked = e.target.checked;
        (0, setValue_1.setValue)({ setState, path, index, valuePath, value: checked, filter });
    }
    function onBlur(_e) {
        setEditing(false);
    }
    function onKey(e) {
        if (e.key === 'Enter' || e.key === ' ' || e.key === 'Spacebar') {
            setEditing(true);
        }
    }
    if (!editing) {
        let value = (0, types_1.getValue)(filter.value, valuePath);
        if (!(0, isset_1.isset)(value))
            value = react_1.default.createElement("span", { className: 'no-value' }, "<enter a value>");
        else
            value = value ? 'Checked' : 'Unchecked';
        return react_1.default.createElement("span", { className: 'filter-editor-value', tabIndex: 0, onKeyDown: onKey, onClick: enableEditing }, value);
    }
    let value = (_a = (0, types_1.getValue)(filter.value, valuePath)) !== null && _a !== void 0 ? _a : false;
    return react_1.default.createElement("input", { ref: inputRef, type: 'checkbox', checked: !!value, onBlur: onBlur, onChange: onChange });
};
exports.BooleanEditor = BooleanEditor;
