"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomEditor = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("./types");
const setValue_1 = require("./setValue");
const isEmpty_1 = require("../../../../utils/isEmpty");
const isset_1 = require("../../../../utils/isset");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faTimesCircle_1 = require("@fortawesome/free-solid-svg-icons/faTimesCircle");
const CustomEditor = function CustomEditor({ useMulti, filterDef, filter, valuePath, setState, path, index }) {
    const [editing, setEditing] = (0, react_1.useState)(false);
    const inputRef = (0, react_1.useRef)(null);
    const focusRef = (0, react_1.useRef)(null);
    const Editor = filterDef.Editor;
    (0, react_1.useEffect)(() => {
        var _a;
        if (!editing)
            return;
        function handleClickOutside(e) {
            var _a;
            if (inputRef.current && inputRef.current !== e.target && !((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.contains(e.target))) {
                setEditing(false);
            }
        }
        if (focusRef.current)
            focusRef.current.focus();
        else
            (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        document.addEventListener('mousedown', handleClickOutside);
        return () => {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, [editing, setEditing]);
    function customOnChange(newValue) {
        (0, setValue_1.setValue)({ setState, path, index, valuePath, value: newValue, filter });
    }
    function onBlur() {
        setEditing(false);
    }
    function onKey(e) {
        if (e.key === 'Enter' || e.key === ' ' || e.key === 'Spacebar') {
            setEditing(true);
        }
    }
    if (useMulti) {
        function removeValue(idxToRemove) {
            setState(path, {
                filters: {
                    [index]: {
                        value: { $splice: [[idxToRemove, 1]] }
                    }
                }
            });
        }
        let value = (0, types_1.getValue)(filter.value, null);
        if (!editing) {
            let { value: noValues } = filter, filterWithoutValues = __rest(filter, ["value"]);
            let displayValue = [];
            let keyBase = [];
            if (!(value === null || value === void 0 ? void 0 : value.length) || (value.length === 1 && value[0] == null)) {
                keyBase.push(JSON.stringify(Object.assign(Object.assign({}, filterWithoutValues), { idx: -1 })));
                displayValue = [
                    react_1.default.createElement("span", { className: 'no-value' }, "<enter a value>")
                ];
            }
            else {
                // generate display values
                value.forEach((val, idx) => {
                    let dspValue = filterDef.toDisplay((0, types_1.getValue)(val, null));
                    displayValue.push(dspValue);
                    keyBase.push(JSON.stringify(Object.assign(Object.assign({}, filterWithoutValues), { idx })));
                });
            }
            return react_1.default.createElement(react_1.default.Fragment, null,
                "(",
                displayValue.map((val, idx, arr) => {
                    return react_1.default.createElement("span", { className: 'multi-value-editor', key: keyBase[idx] + '_' + idx },
                        react_1.default.createElement("span", { className: 'filter-editor-value', tabIndex: 0, onKeyDown: onKey, onClick: () => setEditing(true) }, val),
                        arr.length > 1 && react_1.default.createElement("button", { type: 'button', "data-noautofocus": true, className: 'filter-mv-item-remove filter-btn', onClick: () => removeValue(idx) },
                            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faTimesCircle_1.faTimesCircle })));
                }),
                ")");
        }
        // parent should have already checked filterDef.MultiEditor - so that should be safe
        const MultiEditor = filterDef.MultiEditor;
        return react_1.default.createElement(MultiEditor, { inputRef: inputRef, focusRef: focusRef, value: value, allValues: value, setValue: customOnChange, onLoseFocus: onBlur, editorOptions: filterDef.editorOptions });
    }
    if (!editing) {
        let value = filterDef.toDisplay((0, types_1.getValue)(filter.value, valuePath));
        if (!(0, isset_1.isset)(value))
            value = react_1.default.createElement("span", { className: 'no-value' }, "<enter a value>");
        else if ((0, isEmpty_1.isEmpty)(value))
            value = react_1.default.createElement("span", { className: 'no-value' }, "<empty>");
        return react_1.default.createElement("span", { className: 'filter-editor-value', tabIndex: 0, onKeyDown: onKey, onClick: () => setEditing(true) }, value);
    }
    let value = (0, types_1.getValue)(filter.value, valuePath);
    let allValues = (0, types_1.getValue)(filter.value, null);
    return react_1.default.createElement(Editor, { inputRef: inputRef, focusRef: focusRef, value: value, allValues: allValues, setValue: customOnChange, onLoseFocus: onBlur, editorOptions: filterDef.editorOptions });
};
exports.CustomEditor = CustomEditor;
