"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputEditor = void 0;
const react_1 = __importStar(require("react"));
const isEmpty_1 = require("../../../../utils/isEmpty");
const isset_1 = require("../../../../utils/isset");
const setValue_1 = require("./setValue");
const types_1 = require("./types");
const InputEditor = function InputEditor({ filter, type, setState, path, index, valuePath }) {
    var _a;
    const [editing, setEditing] = (0, react_1.useState)(false);
    const [inputWidth, setWidth] = (0, react_1.useState)(null);
    const inputRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        var _a;
        if (!editing)
            return;
        function handleClickOutside(e) {
            var _a;
            if (inputRef.current && inputRef.current !== e.target && !((_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.contains(e.target))) {
                setEditing(false);
            }
        }
        (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        if (inputRef.current) {
            let parent = inputRef.current.parentElement;
            let afterStyle = window.getComputedStyle(parent, ':after');
            setWidth(afterStyle.width);
        }
        document.addEventListener('mousedown', handleClickOutside);
        return () => {
            document.removeEventListener('mousedown', handleClickOutside);
        };
    }, [editing, setEditing]);
    (0, react_1.useEffect)(() => {
        if (inputRef.current) {
            let parent = inputRef.current.parentElement;
            let afterStyle = window.getComputedStyle(parent, ':after');
            setWidth(afterStyle.width);
        }
    }, [filter.value]);
    function onChange(e) {
        let value = e.target.value;
        if (e.target.type === 'number')
            value = e.target.valueAsNumber;
        (0, setValue_1.setValue)({ setState, path, index, valuePath, value, filter });
    }
    function onBlur(_e) {
        setEditing(false);
    }
    function onKey(e) {
        if (e.key === 'Enter' || e.key === ' ' || e.key === 'Spacebar') {
            setEditing(true);
        }
    }
    if (!editing) {
        let value = (0, types_1.getValue)(filter.value, valuePath);
        if (!(0, isset_1.isset)(value))
            value = react_1.default.createElement("span", { className: 'no-value' }, "<enter a value>");
        else if ((0, isEmpty_1.isEmpty)(value))
            value = react_1.default.createElement("span", { className: 'no-value' }, "<empty>");
        return react_1.default.createElement("span", { className: 'filter-editor-value', tabIndex: 0, onKeyDown: onKey, onClick: () => setEditing(true) }, value);
    }
    let value = (_a = (0, types_1.getValue)(filter.value, valuePath)) !== null && _a !== void 0 ? _a : '';
    if (typeof value === 'number' && Number.isNaN(value))
        value = '';
    return react_1.default.createElement("span", { className: 'input-sizer', "data-value": value },
        react_1.default.createElement("input", { style: { width: inputWidth !== null && inputWidth !== void 0 ? inputWidth : undefined }, ref: inputRef, type: type, value: value, onBlur: onBlur, onChange: onChange }));
};
exports.InputEditor = InputEditor;
