"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.setValue = void 0;
function setValue({ filter, setState, path, index, valuePath, value }) {
    let valueSpec = { $set: value };
    if (typeof valuePath === 'number') {
        // check if exists in filteritem.value
        // may or may not need to convert to/from array
        if (!Array.isArray(filter.value)) {
            let newArray = [filter.value];
            newArray[valuePath] = value;
            valueSpec = { $set: newArray };
        }
        else {
            valueSpec = {
                [valuePath]: { $set: value }
            };
        }
    }
    // no need for else - default action will suffice
    setState(path, {
        filters: {
            [index]: {
                value: valueSpec
            }
        }
    });
}
exports.setValue = setValue;
