"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FilterButton = exports.FilterBar = void 0;
const react_1 = __importStar(require("react"));
const use_dialog_1 = require("@borvik/use-dialog");
const dialog_1 = require("./dialog");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faFilter_1 = require("@fortawesome/free-solid-svg-icons/faFilter");
const contexts_1 = require("../table/contexts");
const use_querystate_1 = require("@borvik/use-querystate");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
var bar_1 = require("./bar");
Object.defineProperty(exports, "FilterBar", { enumerable: true, get: function () { return bar_1.FilterBar; } });
const FilterButton = function FilterButton() {
    var _a, _b, _c, _d, _e;
    const { dialog, showDialog } = (0, use_dialog_1.useDialog)(react_1.default.createElement(dialog_1.FilterDialog, null));
    const { filterColumns, classNames, labels, filter, components, setFilter, setPagination, onShowFilterEditor, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    function applyFilter(filterState) {
        (0, use_querystate_1.batchedQSUpdate)(() => {
            setFilter(filterState);
            setPagination(prev => (Object.assign(Object.assign({}, prev), { page: 1 })));
        });
    }
    function onButtonClick(e) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (onShowFilterEditor) {
                    yield onShowFilterEditor(filter, applyFilter, e.currentTarget);
                }
                else {
                    yield showDialog();
                }
            }
            catch (err) {
                console.error(err);
            }
        });
    }
    let canFilter = false;
    for (let col of filterColumns) {
        if ((_a = col.filter) === null || _a === void 0 ? void 0 : _a.filterKey) {
            canFilter = true;
            break;
        }
    }
    if (!canFilter)
        return react_1.default.createElement(react_1.default.Fragment, null);
    let btnFilterClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonFilter)) {
        btnFilterClass = `${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _b !== void 0 ? _b : ''} ${(_c = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonFilter) !== null && _c !== void 0 ? _c : ''}`.trim();
    }
    const CustomButton = (_d = components === null || components === void 0 ? void 0 : components.Buttons) === null || _d === void 0 ? void 0 : _d.Filter;
    return react_1.default.createElement(react_1.default.Fragment, null,
        dialog,
        !!CustomButton && react_1.default.createElement(CustomButton, { disabled: isEditing && editMode === 'default', onClick: onButtonClick }),
        !CustomButton && react_1.default.createElement("button", { type: 'button', title: (_e = labels === null || labels === void 0 ? void 0 : labels.filter) !== null && _e !== void 0 ? _e : 'Filter', className: btnFilterClass, disabled: isEditing && editMode === 'default', onClick: onButtonClick },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faFilter_1.faFilter })));
};
exports.FilterButton = FilterButton;
