"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Paginate = void 0;
const react_1 = __importStar(require("react"));
const uniqueId_1 = __importDefault(require("lodash/uniqueId"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faCaretLeft_1 = require("@fortawesome/free-solid-svg-icons/faCaretLeft");
const faCaretRight_1 = require("@fortawesome/free-solid-svg-icons/faCaretRight");
const faWindowMinimize_1 = require("@fortawesome/free-solid-svg-icons/faWindowMinimize");
const useDerivedState_1 = require("../../utils/useDerivedState");
const contexts_1 = require("../table/contexts");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const data_provider_1 = require("../table/data-provider");
const Paginate = function Paginate(_a) {
    var { PaginateComponent } = _a, props = __rest(_a, ["PaginateComponent"]);
    const { total } = (0, react_1.useContext)(data_provider_1.TableDataContext);
    const NavigationComponent = PaginateComponent !== null && PaginateComponent !== void 0 ? PaginateComponent : PageNav;
    return react_1.default.createElement(NavigationComponent, Object.assign({}, props, { total: total }));
};
exports.Paginate = Paginate;
/**
 * Guidelines
 *
 * Buttons Together option - keep buttons together before/after Displayed Page data
 *    - or split, prev on left, next on right...
 * Enable/Disable First/Last buttons
 * Edit in place - no reliance on bootstrap popovers
 *    - button triggers edit form, styled in place so it doesn't move (too much anyway)
 */
const PageNav = function PageNav(_a) {
    var _b, _c, _d, _e;
    var { buttonPosition = 'split', perPageOptions = 'default', perPageLoc = 'before' } = _a, props = __rest(_a, ["buttonPosition", "perPageOptions", "perPageLoc"]);
    const [id] = (0, react_1.useState)((0, uniqueId_1.default)('pageSelect_'));
    const [editing, setEditing] = (0, react_1.useState)(false);
    const [pageNum, setPageNum] = (0, useDerivedState_1.useDerivedState)(() => props.page, [props.page, editing]);
    const { labels } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    let totalPages = 0;
    if (typeof props.total !== 'undefined') {
        totalPages = (Math.ceil(props.total / props.perPage) || 1);
    }
    function gotoPage() {
        if (!Number.isNaN(pageNum) && pageNum !== props.page) {
            props.changePage({ page: pageNum });
        }
        setEditing(false);
    }
    return react_1.default.createElement("div", { key: id, className: 'ts-pagination' },
        react_1.default.createElement("div", { className: 'ts-pagination-nav' },
            perPageLoc === 'before' && react_1.default.createElement(PerPageLimitSelect, { total: (_b = props.total) !== null && _b !== void 0 ? _b : -1, totalPages: totalPages, page: props.page, changePage: props.changePage, perPage: props.perPage, perPageOptions: perPageOptions }),
            react_1.default.createElement(PaginateButtons, Object.assign({}, props, { position: 'before', buttonPosition: buttonPosition, totalPages: totalPages })),
            react_1.default.createElement("span", { className: "ts-paginate-label" }, (_c = labels === null || labels === void 0 ? void 0 : labels.page) !== null && _c !== void 0 ? _c : 'Page',
                " ",
                react_1.default.createElement(react_1.default.Fragment, null,
                    !editing && react_1.default.createElement("span", { className: 'ts-paginate-current-page', onClick: isEditing && editMode === 'default' ? undefined : () => setEditing(true) }, props.page),
                    editing && react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement("input", { className: 'ts-paginate-goto-page', ref: (ref) => ref === null || ref === void 0 ? void 0 : ref.focus(), value: Number.isNaN(pageNum) ? '' : pageNum, type: 'number', min: 1, max: totalPages, size: totalPages.toString().length, onChange: (e) => setPageNum(e.target.valueAsNumber), onKeyUp: (e) => {
                                let key = detectKey(e);
                                if (key.isEscape) {
                                    setEditing(false);
                                }
                                else if (key.isEnter) {
                                    gotoPage();
                                }
                            }, onBlur: () => gotoPage() }))),
                " ", (_d = labels === null || labels === void 0 ? void 0 : labels.pageOf) !== null && _d !== void 0 ? _d : 'of',
                " ",
                totalPages),
            react_1.default.createElement(PaginateButtons, Object.assign({}, props, { position: 'after', buttonPosition: buttonPosition, totalPages: totalPages })),
            perPageLoc === 'after' && react_1.default.createElement(PerPageLimitSelect, { total: (_e = props.total) !== null && _e !== void 0 ? _e : -1, totalPages: totalPages, page: props.page, changePage: props.changePage, perPage: props.perPage, perPageOptions: perPageOptions })),
        react_1.default.createElement(TotalLabel, Object.assign({}, props)));
};
const TotalLabel = function TotalLabel(props) {
    if (!props.totalVisible || typeof props.total === 'undefined')
        return null;
    let label = 'total record(s)';
    if (props.totalLabel === false)
        label = '';
    else if (typeof props.totalLabel === 'string')
        label = props.totalLabel;
    else if (props.totalLabel) {
        if (props.total === 1)
            label = props.totalLabel.singular;
        else
            label = props.totalLabel.plural;
    }
    label = ' ' + label;
    return react_1.default.createElement("div", { className: 'ts-pagination-totals' },
        props.total,
        label);
};
const PaginateButtons = function PaginateButtons({ showFirstLast, buttonClass, total, totalPages, position, buttonPosition, page, changePage, }) {
    var _a, _b, _c, _d;
    const { labels } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    const displayBefore = (0, react_1.useMemo)(() => (((position === 'before' &&
        (buttonPosition === 'split' ||
            buttonPosition === 'before')) ||
        (position === 'after' &&
            buttonPosition === 'after')) && totalPages > 1), [totalPages, position, buttonPosition]);
    const displayAfter = (0, react_1.useMemo)(() => (((position === 'after' &&
        (buttonPosition === 'split' ||
            buttonPosition === 'after')) ||
        (position === 'before' &&
            buttonPosition === 'before')) && totalPages > 1), [totalPages, position, buttonPosition]);
    if (!total)
        return null;
    return react_1.default.createElement("div", { className: 'ts-pagination-btn-group' },
        displayBefore && react_1.default.createElement(react_1.default.Fragment, null,
            !!showFirstLast && react_1.default.createElement("button", { type: 'button', title: (_a = labels === null || labels === void 0 ? void 0 : labels.first) !== null && _a !== void 0 ? _a : 'First', className: buttonClass, disabled: page <= 1 || (isEditing && editMode === 'default'), onClick: () => changePage({ page: 1 }) },
                react_1.default.createElement("span", { className: 'fa-layers fa-fw' },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCaretLeft_1.faCaretLeft, fixedWidth: true }),
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faWindowMinimize_1.faWindowMinimize, fixedWidth: true, transform: {
                            size: 10,
                            x: -2,
                            rotate: 90
                        } }))),
            react_1.default.createElement("button", { type: 'button', title: (_b = labels === null || labels === void 0 ? void 0 : labels.previous) !== null && _b !== void 0 ? _b : 'Previous', className: buttonClass, disabled: page <= 1 || (isEditing && editMode === 'default'), onClick: () => changePage({ page: page - 1 }) },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCaretLeft_1.faCaretLeft, fixedWidth: true }))),
        displayAfter && react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("button", { type: 'button', title: (_c = labels === null || labels === void 0 ? void 0 : labels.next) !== null && _c !== void 0 ? _c : 'Next', className: buttonClass, disabled: page >= totalPages || (isEditing && editMode === 'default'), onClick: () => changePage({ page: page + 1 }) },
                react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCaretRight_1.faCaretRight, fixedWidth: true })),
            !!showFirstLast && react_1.default.createElement("button", { type: 'button', title: (_d = labels === null || labels === void 0 ? void 0 : labels.last) !== null && _d !== void 0 ? _d : 'Last', className: buttonClass, disabled: page >= totalPages || (isEditing && editMode === 'default'), onClick: () => changePage({ page: totalPages }) },
                react_1.default.createElement("span", { className: 'fa-layers fa-fw' },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCaretRight_1.faCaretRight, fixedWidth: true }),
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faWindowMinimize_1.faWindowMinimize, fixedWidth: true, transform: {
                            size: 10,
                            x: 2,
                            rotate: 270 // 90
                        } })))));
};
const PerPageLimitSelect = function PerPageLimitSelect({ page, total, totalPages, perPage, perPageOptions, changePage }) {
    var _a, _b;
    const { labels } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    const [pageLimit, setPageLimit] = (0, useDerivedState_1.useDerivedState)(() => perPage, [perPage]);
    const pageOptions = (0, react_1.useMemo)(() => {
        if (perPageOptions === 'any')
            return [];
        let options = [];
        if (perPageOptions !== 'default') {
            options = [...perPageOptions];
        }
        else {
            options = [10, 25, 50, 75, 100, 125];
        }
        if (!options.includes(perPage)) {
            options.push(perPage);
            options = options.sort((a, b) => a - b);
        }
        return options;
    }, [perPageOptions, perPage]);
    if (perPageOptions !== 'any' && !pageOptions.length)
        return null;
    function changePerPage(limit) {
        if (typeof limit === 'undefined') {
            if (Number.isNaN(pageLimit)) {
                setPageLimit(perPage);
                return;
            }
            limit = pageLimit;
        }
        let newState = { perPage: limit };
        if (total <= limit && page !== 1) {
            newState.page = 1;
        }
        else {
            let newTotalPages = (Math.ceil(total / limit) || 1);
            if (page > newTotalPages)
                newState.page = newTotalPages;
        }
        changePage(newState);
    }
    return react_1.default.createElement("div", { className: 'per-page-select' },
        perPageOptions === 'any' && react_1.default.createElement(react_1.default.Fragment, null, (_a = labels === null || labels === void 0 ? void 0 : labels.perPage) !== null && _a !== void 0 ? _a : 'Per Page',
            react_1.default.createElement("input", { type: 'number', min: 1, disabled: isEditing && editMode === 'default', value: Number.isNaN(pageLimit) ? '' : pageLimit, onChange: (e) => { setPageLimit(e.target.valueAsNumber); }, onKeyUp: (e) => {
                    let key = detectKey(e);
                    if (key.isEscape) {
                        setPageLimit(perPage);
                    }
                    else if (key.isEnter) {
                        changePerPage();
                    }
                }, onBlur: () => changePerPage() })),
        perPageOptions !== 'any' && react_1.default.createElement(react_1.default.Fragment, null,
            pageOptions.length > 1 && react_1.default.createElement("select", { disabled: isEditing && editMode === 'default', value: perPage, onChange: (e) => changePerPage(parseInt(e.target.value)) }, pageOptions.map(page => (react_1.default.createElement("option", { key: page, value: page }, page)))),
            pageOptions.length === 1 && react_1.default.createElement("span", null,
                perPage,
                " "),
            react_1.default.createElement("span", null, (_b = labels === null || labels === void 0 ? void 0 : labels.perPage) !== null && _b !== void 0 ? _b : 'Per Page')));
};
function detectKey(e) {
    if (e.key) {
        return {
            isEscape: (e.key === 'Escape' || e.key === 'Esc'),
            isEnter: (e.key === 'Enter')
        };
    }
    if (e.which) {
        return {
            isEscape: (e.which === 27),
            isEnter: (e.which === 13),
        };
    }
    return {
        isEscape: (e.keyCode === 27),
        isEnter: (e.keyCode === 13),
    };
}
