"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RowSelector = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../table/contexts");
const getRowKey_1 = require("../../utils/getRowKey");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const checkbox_1 = require("./checkbox");
const select_all_1 = require("./select-all");
const RowSelector = function RowSelector(_a) {
    var _b;
    var { row, rowIndex } = _a, props = __rest(_a, ["row", "rowIndex"]);
    const { actualColumns: columns, canSelectRow, getRowKey: propsGetRowKey, setRowSelected, components, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const Checkbox = (_b = components === null || components === void 0 ? void 0 : components.RowCheckbox) !== null && _b !== void 0 ? _b : checkbox_1.RowSelectorCheckbox;
    if (rowIndex < 0) {
        // Select ALL
        return react_1.default.createElement(select_all_1.AllRowsSelector, null);
    }
    if (typeof canSelectRow === 'function' && !canSelectRow(row)) {
        return react_1.default.createElement(react_1.default.Fragment, null);
    }
    const rowKey = (0, getRowKey_1.getRowKey)(row, rowIndex, columns, propsGetRowKey);
    const [{ isSelected }] = (0, contexts_1.useTableSelector)(c => ({
        isSelected: typeof c.selectedRows[rowKey] !== 'undefined'
    }), isEqual_1.default);
    return react_1.default.createElement("div", null,
        react_1.default.createElement(Checkbox, { row: row, checked: isSelected, indeterminate: false, onChange: () => setRowSelected(row, rowIndex) }));
};
exports.RowSelector = RowSelector;
