"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AllRowsSelector = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../table/contexts");
const checkbox_1 = require("./checkbox");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const data_provider_1 = require("../table/data-provider");
const AllRowsSelector = function AllRowsSelector(_a) {
    var _b;
    var props = __rest(_a, []);
    const { data } = (0, react_1.useContext)(data_provider_1.TableDataContext);
    const { canSelectRow, setAllSelected, components, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ selectedRows }] = (0, contexts_1.useTableSelector)(c => ({ selectedRows: c.selectedRows }), isEqual_1.default);
    const Checkbox = (_b = components === null || components === void 0 ? void 0 : components.RowCheckbox) !== null && _b !== void 0 ? _b : checkbox_1.RowSelectorCheckbox;
    const rowData = data !== null && data !== void 0 ? data : [];
    const filteredRowData = rowData.filter(rw => (typeof canSelectRow !== 'function' || canSelectRow(rw)));
    const selectedKeys = Object.keys(selectedRows);
    const isChecked = (!!filteredRowData.length && selectedKeys.length === filteredRowData.length);
    const isIndeterminite = (!!filteredRowData.length && !!selectedKeys.length && filteredRowData.length !== selectedKeys.length);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(Checkbox, { checked: isChecked, indeterminate: isIndeterminite, onChange: () => {
                if (!filteredRowData.length)
                    return;
                setAllSelected(!!filteredRowData.length && selectedKeys.length !== filteredRowData.length, filteredRowData);
            } })));
};
exports.AllRowsSelector = AllRowsSelector;
