"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchForm = void 0;
const react_1 = __importStar(require("react"));
const useDerivedState_1 = require("../../utils/useDerivedState");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faSearch_1 = require("@fortawesome/free-solid-svg-icons/faSearch");
const contexts_1 = require("../table/contexts");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const SearchForm = function SearchForm(props) {
    var _a, _b;
    const { labels } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [searchQuery, setSearchQuery] = (0, useDerivedState_1.useDerivedState)(() => props.searchQuery, [props.searchQuery]);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    return (react_1.default.createElement("form", { className: 'ts-datatable-search-form', onSubmit: isEditing && editMode === 'default' ? undefined : (e) => {
            e.preventDefault();
            e.stopPropagation();
            props.onSearch(searchQuery);
        } },
        react_1.default.createElement("input", { type: 'search', value: searchQuery, placeholder: (_a = labels === null || labels === void 0 ? void 0 : labels.search) !== null && _a !== void 0 ? _a : 'Search', disabled: isEditing && editMode === 'default', onChange: (e) => setSearchQuery(e.target.value) }),
        react_1.default.createElement("button", { type: 'submit', title: (_b = labels === null || labels === void 0 ? void 0 : labels.search) !== null && _b !== void 0 ? _b : 'Search', disabled: isEditing && editMode === 'default' },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSearch_1.faSearch }))));
};
exports.SearchForm = SearchForm;
