"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableRefreshButton = exports.TableActionButtons = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("./contexts");
const free_solid_svg_icons_1 = require("@fortawesome/free-solid-svg-icons");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const data_provider_1 = require("./data-provider");
const TableActionButtons = function TableActionButtons({ position, quickEditPosition, buttons }) {
    let showQuickEdit = false;
    if (position === 'top') {
        showQuickEdit = (quickEditPosition === 'top' || quickEditPosition === 'both');
    }
    else {
        // bottom
        showQuickEdit = (quickEditPosition === 'bottom' || quickEditPosition === 'both');
    }
    return react_1.default.createElement(react_1.default.Fragment, null,
        position === 'top' && buttons.refresh,
        showQuickEdit && buttons.quickEdit,
        position === 'top' && buttons.filter,
        position === 'top' && buttons.columnPicker);
};
exports.TableActionButtons = TableActionButtons;
const TableRefreshButton = function TableRefreshButton({ hideRefetch }) {
    var _a, _b, _c, _d;
    const { refetch } = (0, react_1.useContext)(data_provider_1.TableDataContext);
    const { classNames, labels, components, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const onButtonClick = (0, react_1.useCallback)((e) => __awaiter(this, void 0, void 0, function* () {
        e.preventDefault();
        e.stopPropagation();
        refetch === null || refetch === void 0 ? void 0 : refetch();
    }), [refetch]);
    if (typeof refetch !== 'function' || hideRefetch)
        return null;
    let btnSettingsClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonRefresh)) {
        btnSettingsClass = `${(_a = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _a !== void 0 ? _a : ''} ${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonRefresh) !== null && _b !== void 0 ? _b : ''}`.trim();
    }
    const CustomButton = (_c = components === null || components === void 0 ? void 0 : components.Buttons) === null || _c === void 0 ? void 0 : _c.Refresh;
    return react_1.default.createElement(react_1.default.Fragment, null,
        !!CustomButton && react_1.default.createElement(CustomButton, { onClick: onButtonClick }),
        !CustomButton && react_1.default.createElement("button", { type: 'button', title: (_d = labels === null || labels === void 0 ? void 0 : labels.refresh) !== null && _d !== void 0 ? _d : 'Refresh', className: btnSettingsClass, onClick: onButtonClick },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: free_solid_svg_icons_1.faSyncAlt })));
};
exports.TableRefreshButton = TableRefreshButton;
