"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableBody = void 0;
const react_1 = __importStar(require("react"));
const types_1 = require("./types");
const contexts_1 = require("./contexts");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faCircleNotch_1 = require("@fortawesome/free-solid-svg-icons/faCircleNotch");
const table_row_1 = require("./table-row");
const getRowKey_1 = require("../../utils/getRowKey");
const useDerivedState_1 = require("../../utils/useDerivedState");
const getGroupKey_1 = require("../../utils/getGroupKey");
const table_group_1 = require("./table-group");
const immutable_1 = require("../../utils/immutable");
const data_provider_1 = require("./data-provider");
const TableBody = function TableBody(_a) {
    var { canEditRow, LoadingComponent } = _a, props = __rest(_a, ["canEditRow", "LoadingComponent"]);
    const { data, loading, dataError } = (0, react_1.useContext)(data_provider_1.TableDataContext);
    const { actualColumns: columns, groupBy } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const tbodyRef = (0, react_1.useRef)(null);
    let [groupedData] = (0, useDerivedState_1.useArrayDerivedState)(() => {
        var _a;
        if (!groupBy.length) {
            return data.map((row, rowIndex) => ({
                row,
                rowIndex,
                key: (0, getRowKey_1.getRowKey)(row, rowIndex, columns, props.getRowKey),
            }));
        }
        let nestedGroups = [];
        for (let i = 0; i < data.length; i++) {
            // get group values as a array
            let groupValues = (0, getGroupKey_1.getGroupKeys)(data[i], groupBy, columns);
            let currentGroup = [], currentGroupKey, lastGroup = null;
            while (groupValues.length) {
                let grp = groupValues.shift();
                currentGroup.push(grp);
                currentGroupKey = (0, getGroupKey_1.getGroupKey)(currentGroup);
                let grpContainer = (_a = lastGroup === null || lastGroup === void 0 ? void 0 : lastGroup.children) !== null && _a !== void 0 ? _a : nestedGroups;
                // eslint (no-loop-func)
                // eslint-disable-next-line
                let dgrp = grpContainer.find(g => g.key === currentGroupKey);
                if (!dgrp) {
                    dgrp = {
                        key: currentGroupKey,
                        level: currentGroup.length,
                        column: grp.column,
                        value: grp.value,
                        children: [],
                        firstRow: data[i],
                    };
                    grpContainer.push(dgrp);
                }
                lastGroup = dgrp;
            }
            lastGroup.children.push({
                row: data[i],
                rowIndex: i,
                key: (0, getRowKey_1.getRowKey)(data[i], i, columns, props.getRowKey),
            });
        }
        return nestedGroups;
    }, [columns, groupBy, data]);
    let [groupCollapsed, setGroupCollapsed] = (0, react_1.useState)({});
    function setGroupExpanded(groupKey, expanded) {
        setGroupCollapsed(state => (0, immutable_1.update)(state, { [groupKey]: { $set: expanded } }));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(contexts_1.GroupCollapseContext.Provider, { value: { collapsedState: groupCollapsed, setExpanded: setGroupExpanded } },
            react_1.default.createElement("tbody", { ref: tbodyRef, className: `${!data.length && loading ? 'ts-loading' : ''}` },
                !!dataError && react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement("tr", null,
                        react_1.default.createElement("td", { className: 'ts-datatable-error', colSpan: columns.length }, dataError))),
                (0, types_1.isDataGroupArray)(groupedData) && react_1.default.createElement(react_1.default.Fragment, null, groupedData.map(grp => react_1.default.createElement(table_group_1.TableGroup, { key: grp.key, group: grp, canEditRow: canEditRow }))),
                (0, types_1.isDataRowArray)(groupedData) && react_1.default.createElement(react_1.default.Fragment, null, groupedData.map(row => react_1.default.createElement(table_row_1.TableRow, { key: row.key, rowIndex: row.rowIndex, row: row.row, canEditRow: canEditRow }))))),
        loading && react_1.default.createElement("tbody", { className: 'ts-datatable-loader', ref: (el) => {
                const tbodyEl = tbodyRef.current;
                if (tbodyEl && el) {
                    // find wrapper
                    const tableEl = tbodyEl.parentElement;
                    const theadEl = tableEl.querySelector('thead');
                    const wrapperEl = tableEl.parentElement;
                    const tbodyPos = tbodyEl.getBoundingClientRect();
                    const theadPos = theadEl.getBoundingClientRect();
                    const wrapperPos = wrapperEl.getBoundingClientRect();
                    el.style.left = wrapperPos.left + 'px';
                    // el.style.right = wrapperPos.right + 'px';
                    el.style.top = tbodyPos.top + 'px';
                    // el.style.bottom = wrapperPos.bottom + 'px';
                    el.style.width = wrapperPos.width + 'px';
                    el.style.height = (wrapperPos.height - theadPos.height) + 'px';
                    el.style.fontSize = Math.min(((wrapperPos.height - theadPos.height) * .7), wrapperPos.width * .7) + 'px';
                }
            } },
            react_1.default.createElement("tr", null,
                react_1.default.createElement("td", { colSpan: columns.length }, LoadingComponent !== null && LoadingComponent !== void 0 ? LoadingComponent : react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faCircleNotch_1.faCircleNotch, spin: true }))))));
};
exports.TableBody = TableBody;
