"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnSearchInput = void 0;
const react_1 = __importDefault(require("react"));
const text_input_1 = require("./text-input");
const select_input_1 = require("./select-input");
const boolean_select_input_1 = require("./boolean-select-input");
const custom_input_1 = require("./custom-input");
const ColumnSearchInput = function ColumnSearchInput(props) {
    const { columnSearch } = props, rest = __rest(props, ["columnSearch"]);
    if (columnSearch.type === 'string') {
        return react_1.default.createElement(text_input_1.TextInput, Object.assign({ columnSearch: columnSearch }, rest));
    }
    else if (columnSearch.type === 'select') {
        return react_1.default.createElement(select_input_1.SelectInput, Object.assign({ columnSearch: columnSearch }, rest));
    }
    else if (columnSearch.type === 'boolean') {
        return react_1.default.createElement(boolean_select_input_1.BooleanSelectInput, Object.assign({ columnSearch: columnSearch }, rest));
    }
    else if (columnSearch.type === 'custom') {
        return react_1.default.createElement(custom_input_1.CustomInput, Object.assign({ columnSearch: columnSearch }, rest));
    }
    return null;
};
exports.ColumnSearchInput = ColumnSearchInput;
