"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnSearch = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../contexts");
const types_1 = require("../types");
const useDerivedState_1 = require("../../../utils/useDerivedState");
const use_querystate_1 = require("@borvik/use-querystate");
const column_search_input_1 = require("./column-search-input");
const ColumnSearch = function ColumnSearch(props) {
    const { hasValidPreMDRColumn, hasDetailRenderer } = props;
    const { actualColumns, canSelectRows, filter, setFilter, setPagination, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [columnSearchQueries, setColumnSearchQueries] = (0, useDerivedState_1.useDerivedState)(() => {
        const columnSearchQueries = {};
        if (filter.groupOperator === 'and') {
            for (const columnFilter of filter.filters) {
                if ((0, types_1.isFilterItem)(columnFilter)) {
                    const actualColumn = actualColumns.findIndex(c => { var _a, _b, _c; return (((_b = (_a = c.columnSearch) === null || _a === void 0 ? void 0 : _a.customSearchKey) !== null && _b !== void 0 ? _b : c.accessor) == columnFilter.column && ((_c = c.columnSearch) === null || _c === void 0 ? void 0 : _c.columnSearchOperator) == columnFilter.operator); });
                    if (actualColumn !== -1) {
                        columnSearchQueries[columnFilter.column] = columnFilter.value;
                    }
                }
            }
            ;
        }
        return columnSearchQueries;
    }, [filter, actualColumns]);
    const onSubmit = (0, react_1.useCallback)((e) => {
        e === null || e === void 0 ? void 0 : e.preventDefault();
        (0, use_querystate_1.batchedQSUpdate)(() => {
            setFilter((prevFilter) => {
                if (prevFilter.groupOperator === 'and') {
                    const filtersToConcat = [];
                    const modifiedColumns = Object.keys(columnSearchQueries);
                    const existingFilters = prevFilter.filters.map(filter => {
                        var _a;
                        if ((0, types_1.isFilterItem)(filter) && modifiedColumns.includes(filter.column)) {
                            const actualColumn = actualColumns.find(c => { var _a, _b; return (((_b = (_a = c.columnSearch) === null || _a === void 0 ? void 0 : _a.customSearchKey) !== null && _b !== void 0 ? _b : c.accessor) == filter.column); });
                            const value = columnSearchQueries[filter.column];
                            if (((_a = actualColumn === null || actualColumn === void 0 ? void 0 : actualColumn.columnSearch) === null || _a === void 0 ? void 0 : _a.columnSearchOperator) == filter.operator) {
                                return Object.assign(Object.assign({}, filter), { value });
                            }
                        }
                        return filter;
                    });
                    for (const column of modifiedColumns) {
                        const actualColumn = actualColumns.find(c => { var _a, _b; return (((_b = (_a = c.columnSearch) === null || _a === void 0 ? void 0 : _a.customSearchKey) !== null && _b !== void 0 ? _b : c.accessor) == column); });
                        if (actualColumn === null || actualColumn === void 0 ? void 0 : actualColumn.columnSearch) {
                            if (existingFilters.findIndex(filter => ((0, types_1.isFilterItem)(filter) && filter.column == column && actualColumn.columnSearch.columnSearchOperator === filter.operator)) == -1) {
                                const value = columnSearchQueries[column];
                                if (value != null && value != '') {
                                    filtersToConcat.push({
                                        column,
                                        value,
                                        operator: actualColumn.columnSearch.columnSearchOperator,
                                    });
                                }
                            }
                        }
                    }
                    return Object.assign(Object.assign({}, prevFilter), { filters: [...existingFilters, ...filtersToConcat].filter(f => (!(0, types_1.isFilterItem)(f) || (f.value != null && f.value != ''))) });
                }
                else {
                    const searchFilters = [];
                    for (const column of Object.keys(columnSearchQueries)) {
                        if (columnSearchQueries[column] != null) {
                            const actualColumn = actualColumns.find(c => { var _a, _b; return (((_b = (_a = c.columnSearch) === null || _a === void 0 ? void 0 : _a.customSearchKey) !== null && _b !== void 0 ? _b : c.accessor) == column); });
                            if (actualColumn === null || actualColumn === void 0 ? void 0 : actualColumn.columnSearch) {
                                searchFilters.push({
                                    column,
                                    value: columnSearchQueries[column],
                                    operator: actualColumn.columnSearch.columnSearchOperator,
                                });
                            }
                        }
                    }
                    ;
                    return {
                        groupOperator: 'and',
                        filters: [
                            Object.assign({}, prevFilter),
                            ...searchFilters,
                        ].filter(f => (!(0, types_1.isFilterItem)(f) || (f.value != null && f.value != ''))),
                    };
                }
            });
            setPagination(prev => (Object.assign(Object.assign({}, prev), { page: 1 })));
        });
    }, [columnSearchQueries, actualColumns, setPagination, setFilter]);
    const onColumnSearchInput = (0, react_1.useCallback)((newValue, column) => {
        setColumnSearchQueries((prevState) => (Object.assign(Object.assign({}, prevState), { [column]: newValue })));
    }, [setColumnSearchQueries]);
    return react_1.default.createElement("tr", { className: "ts-data-table-column-search-row" },
        hasValidPreMDRColumn && react_1.default.createElement("th", null),
        hasDetailRenderer && react_1.default.createElement("th", null),
        canSelectRows && react_1.default.createElement("th", null),
        actualColumns.map((column, index) => {
            var _a, _b;
            if (!column.isVisible || !column.enabled || column.isGrouped) {
                return null;
            }
            else {
                const searchKey = (_b = (_a = column === null || column === void 0 ? void 0 : column.columnSearch) === null || _a === void 0 ? void 0 : _a.customSearchKey) !== null && _b !== void 0 ? _b : column.accessor;
                return react_1.default.createElement("th", { key: `${column.key}-${index}` }, !!(column.columnSearch && searchKey) && react_1.default.createElement("form", { onSubmit: onSubmit },
                    react_1.default.createElement(column_search_input_1.ColumnSearchInput, { columnSearch: column.columnSearch, searchKey: searchKey, value: columnSearchQueries[searchKey], onColumnSearchInput: onColumnSearchInput, onSubmit: onSubmit })));
            }
        }));
};
exports.ColumnSearch = ColumnSearch;
