import React, { PropsWithChildren } from 'react';
import { ColumnSort, DataFn, DataProps, Pagination, QueryFilterGroup } from './types';
export interface TableDataContextInterface {
    loading: boolean;
    data: any[];
    footerData?: any[];
    total?: number;
    refetch?: () => void;
    dataError?: string;
}
export declare const TableDataContext: React.Context<TableDataContextInterface>;
export declare const DataProviderContent: React.FC<PropsWithChildren<TableDataContextInterface>>;
interface TableDataArgs<T = any, FooterData = any> {
    passColumnsToQuery?: boolean;
    pagination: Pagination;
    searchQuery?: null | string;
    onQueryChange?: (props: DataProps<T>) => void;
    data?: DataFn<T[], FooterData[]> | T[];
    totalCount?: number;
    isLoading?: boolean;
    footerData?: FooterData[];
    refetch?: () => void;
    canGroupBy: boolean;
    filters: QueryFilterGroup;
    sorts: ColumnSort[];
}
export interface TableDataProviderProps extends TableDataArgs {
    TableBody: React.ElementType<PropsWithChildren<TableDataContextInterface>>;
    children: React.ReactNode;
}
export declare const TableDataProvider: React.FC<TableDataProviderProps>;
export {};
