"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BooleanEditor = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../contexts");
const getRowKey_1 = require("../../../utils/getRowKey");
const immutable_1 = require("../../../utils/immutable");
const get_1 = __importDefault(require("lodash/get"));
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const useSaveQuickEdit_1 = require("../useSaveQuickEdit");
const BooleanEditor = function BooleanEditor({ row, column, value }) {
    const { actualColumns: columns, getRowKey, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const onSaveQuickEdit = (0, useSaveQuickEdit_1.useSaveQuickEdit)();
    // yes we should be able to count on this
    // earlier validation assures editing only if either
    // getRowKey is set OR a primary key column is set
    let primaryColumn = columns.find(c => c.isPrimaryKey);
    let keyValue = typeof getRowKey === 'function'
        ? getRowKey(row)
        : (0, getRowKey_1.getRowValue)(row, primaryColumn);
    const [{ rowData, editMode, }, setCtxData] = (0, contexts_1.useTableSelector)(c => {
        let rowData = (0, get_1.default)(c.editData, keyValue, {});
        return {
            rowData,
            editMode: c.editMode,
        };
    }, isEqual_1.default);
    let actualValue = (0, get_1.default)(rowData, column.key, value);
    function onChange(e) {
        let fieldValue = e.target.checked;
        if (editMode === 'autosave') {
            onSaveQuickEdit({
                [keyValue]: {
                    [column.key]: fieldValue
                }
            });
        }
        else {
            setCtxData(data => (0, immutable_1.update)(data, {
                editData: {
                    [keyValue]: { $auto: {
                            [column.key]: { $set: fieldValue }
                        } }
                }
            }));
        }
    }
    return react_1.default.createElement("input", { type: 'checkbox', checked: actualValue, onChange: onChange });
};
exports.BooleanEditor = BooleanEditor;
