"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableEditorButton = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("../contexts");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faPencilAlt_1 = require("@fortawesome/free-solid-svg-icons/faPencilAlt");
const faBan_1 = require("@fortawesome/free-solid-svg-icons/faBan");
const faSave_1 = require("@fortawesome/free-solid-svg-icons/faSave");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const useSaveQuickEdit_1 = require("../useSaveQuickEdit");
const TableEditorButton = function TableEditorButton({ canEdit }) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
    const onSaveQuickEdit = (0, useSaveQuickEdit_1.useSaveQuickEdit)();
    const { classNames, labels, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, editData, isSavingQuickEdit, }, setCtxData] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
        editData: c.editData,
        isSavingQuickEdit: c.isSavingQuickEdit,
    }), isEqual_1.default);
    if (editMode === 'autosave')
        return null;
    if (!isEditing && editMode === 'default') {
        if (canEdit) {
            let btnEditClass;
            if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonEdit))
                btnEditClass = `${(_a = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _a !== void 0 ? _a : ''} ${(_b = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonEdit) !== null && _b !== void 0 ? _b : ''}`.trim();
            return react_1.default.createElement("div", { className: 'quick-edit-btn-group' },
                react_1.default.createElement("button", { type: 'button', className: btnEditClass, onClick: () => setCtxData({ isEditing: true }), title: (_c = labels === null || labels === void 0 ? void 0 : labels.quickEdit) !== null && _c !== void 0 ? _c : 'Quick Edit' },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faPencilAlt_1.faPencilAlt })));
        }
        return null;
    }
    let btnDiscardClass;
    let btnSaveClass;
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonDiscard)) {
        btnDiscardClass = `${(_d = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _d !== void 0 ? _d : ''} ${(_e = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonDiscard) !== null && _e !== void 0 ? _e : ''}`.trim();
    }
    if ((classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) || (classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonSave)) {
        btnSaveClass = `${(_f = classNames === null || classNames === void 0 ? void 0 : classNames.actionButton) !== null && _f !== void 0 ? _f : ''} ${(_g = classNames === null || classNames === void 0 ? void 0 : classNames.actionButtonSave) !== null && _g !== void 0 ? _g : ''}`.trim();
    }
    if (Object.keys(editData).length) {
        btnSaveClass = `${btnSaveClass !== null && btnSaveClass !== void 0 ? btnSaveClass : ''} is-dirty`;
    }
    return react_1.default.createElement("div", { className: 'quick-edit-btn-group editing' },
        react_1.default.createElement("label", null, (_h = labels === null || labels === void 0 ? void 0 : labels.quickEdit) !== null && _h !== void 0 ? _h : 'Quick Edit'),
        react_1.default.createElement("button", { type: 'button', className: btnSaveClass, title: (_j = labels === null || labels === void 0 ? void 0 : labels.saveChanges) !== null && _j !== void 0 ? _j : 'Save Changes', disabled: isSavingQuickEdit, onClick: () => {
                onSaveQuickEdit(editData);
            } },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSave_1.faSave })),
        react_1.default.createElement("button", { type: 'button', className: btnDiscardClass, title: (_k = labels === null || labels === void 0 ? void 0 : labels.discardChanges) !== null && _k !== void 0 ? _k : 'Discard Changes', disabled: isSavingQuickEdit, onClick: () => {
                setCtxData({
                    editData: {},
                    isEditing: false
                });
            } },
            react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faBan_1.faBan })));
};
exports.TableEditorButton = TableEditorButton;
