"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CellEditor = void 0;
const react_1 = __importDefault(require("react"));
const input_1 = require("./input");
const boolean_1 = require("./boolean");
const custom_1 = require("./custom");
const CellEditor = function CellEditor({ column, value, row, rowIndex }) {
    switch (column.editor.type) {
        case 'text':
        case 'number':
        case 'email':
            return react_1.default.createElement(input_1.InputEditor, { type: column.editor.type, column: column, value: value, row: row, rowIndex: rowIndex });
        case 'checkbox':
            return react_1.default.createElement(boolean_1.BooleanEditor, { column: column, value: value, row: row, rowIndex: rowIndex });
        case 'custom':
            return react_1.default.createElement(custom_1.CustomEditor, { column: column, value: value, row: row, rowIndex: rowIndex });
        default:
            let rendered = typeof column.render !== 'undefined'
                ? column.render(value, row, column, rowIndex)
                : value;
            return react_1.default.createElement(react_1.default.Fragment, null, rendered);
    }
};
exports.CellEditor = CellEditor;
