"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableFooter = void 0;
const react_1 = __importStar(require("react"));
const getRowKey_1 = require("../../utils/getRowKey");
const useDerivedState_1 = require("../../utils/useDerivedState");
const contexts_1 = require("./contexts");
const data_provider_1 = require("./data-provider");
const types_1 = require("./types");
const TableFooterRow = function TableFooterRow({ row }) {
    var _a;
    const { actualColumns: columns, DetailRow, canSelectRows, getTableCellProps, preMDRColumn, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    let hasDetailRenderer = (!!DetailRow);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("tr", null,
            (0, types_1.isValidPreMDRColumn)(preMDRColumn) && react_1.default.createElement("td", { key: 'premdr', className: `fixed fixed-left premdr-col ${(_a = preMDRColumn.className) !== null && _a !== void 0 ? _a : ''}`.trim() }),
            hasDetailRenderer && react_1.default.createElement("td", { key: `mdr`, className: 'fixed fixed-left mdr-control' }),
            canSelectRows && react_1.default.createElement("td", { key: `sel`, className: 'fixed fixed-left row-selector' }),
            columns.map((col) => {
                var _a, _b;
                if (!col.isVisible || col.isGrouped)
                    return null;
                let value = (0, getRowKey_1.getRowValue)(row, col);
                let rendered = typeof col.renderFooter !== 'undefined'
                    ? col.renderFooter(value, row, col)
                    : value;
                let classNames = [(_a = col.className) !== null && _a !== void 0 ? _a : '', col.fixed ? `fixed fixed-${col.fixed}` : ''];
                let cellProps = {};
                if (getTableCellProps && typeof getTableCellProps === 'function') {
                    cellProps = (_b = getTableCellProps(value, row, col)) !== null && _b !== void 0 ? _b : {};
                    if (cellProps.className) {
                        classNames.push(cellProps.className);
                    }
                    classNames = classNames.filter(s => !!s);
                }
                cellProps.className = classNames.join(' ').trim();
                return react_1.default.createElement("td", Object.assign({}, cellProps, { key: col.key }), rendered);
            })));
};
const TableFooter = function TableFooter({}) {
    const { footerData } = (0, react_1.useContext)(data_provider_1.TableDataContext);
    if (!(footerData === null || footerData === void 0 ? void 0 : footerData.length))
        return null;
    return react_1.default.createElement(TFooter, { data: footerData });
};
exports.TableFooter = TableFooter;
const TFooter = function TFooter({ data }) {
    const { actualColumns: columns, groupBy } = (0, react_1.useContext)(contexts_1.ColumnContext);
    let [footerData] = (0, useDerivedState_1.useArrayDerivedState)(() => {
        return data.map((row, rowIndex) => ({
            row,
            rowIndex,
            key: rowIndex,
        }));
    }, [columns, data]);
    return (react_1.default.createElement("tfoot", null, footerData.map(row => react_1.default.createElement(TableFooterRow, { key: row.key, row: row.row }))));
};
