"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableHeader = void 0;
const react_1 = __importStar(require("react"));
const setColumnSort_1 = require("../../utils/setColumnSort");
const row_selector_1 = require("../row-selector");
const contexts_1 = require("./contexts");
const sortable_1 = require("./sortable");
const types_1 = require("./types");
const column_search_1 = require("./column-search");
const TableHeader = function TableHeader(props) {
    const { headerRows, columnSorts, multiColumnSorts, setColumnSort, DetailRow, canSelectRows, groupBy, preMDRColumn, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    if (headerRows.length < 1)
        return null;
    let hasDetailRenderer = (!!DetailRow);
    let indentStyle = { '--indent': groupBy.length };
    const hasValidPreMDRColumn = (0, types_1.isValidPreMDRColumn)(preMDRColumn);
    return (react_1.default.createElement("thead", { ref: props.headRef },
        headerRows.map((row, rowIdx) => (react_1.default.createElement("tr", { key: rowIdx, className: 'ts-datatable-header-row' }, row.map((col, colIdx) => {
            var _a, _b;
            if (!col.isVisible)
                return null;
            let colScope = col.colSpan > 1 ? 'colgroup' : 'col';
            const isSortable = (col.sortable && col.colSpan === 1 && col.name);
            const sort = columnSorts.find(s => s.column === col.name);
            function onClick(e) {
                let newSort = sort
                    ? Object.assign(Object.assign({}, sort), { direction: sort.direction === 'asc' ? 'desc' : 'asc' }) : { column: col.name, direction: col.defaultSortDir };
                (0, setColumnSort_1.doSetColumnSort)(setColumnSort, newSort, e.shiftKey, multiColumnSorts);
            }
            return (react_1.default.createElement(react_1.default.Fragment, { key: `row-key-${colIdx}` },
                (colIdx === 0 && rowIdx === 0) && react_1.default.createElement(react_1.default.Fragment, null,
                    hasValidPreMDRColumn && react_1.default.createElement("th", { scope: 'col', style: indentStyle, key: 'premdr', rowSpan: headerRows.length, className: `fixed fixed-left premdr-col ${(_a = preMDRColumn.className) !== null && _a !== void 0 ? _a : ''}`.trim() },
                        react_1.default.createElement("span", { className: 'ts-datatable-header-cell' })),
                    hasDetailRenderer && react_1.default.createElement("th", { scope: 'col', style: indentStyle, key: 'mdr', rowSpan: headerRows.length, className: 'fixed fixed-left mdr-control' },
                        react_1.default.createElement("span", { className: 'ts-datatable-header-cell' })),
                    canSelectRows && react_1.default.createElement("th", { scope: 'col', style: indentStyle, key: 'sel', rowSpan: headerRows.length, className: 'fixed fixed-left row-selector' },
                        react_1.default.createElement("span", { className: 'ts-datatable-header-cell' },
                            react_1.default.createElement(row_selector_1.RowSelector, { row: null, rowIndex: -1 })))),
                react_1.default.createElement("th", { key: colIdx, style: colIdx === 0 && col.fixed ? indentStyle : undefined, className: `${(_b = col.className) !== null && _b !== void 0 ? _b : ''} ${col.fixed ? `fixed fixed-${col.fixed}` : ''}`.trim(), colSpan: col.colSpan > 1 ? col.colSpan : undefined, rowSpan: col.rowSpan > 1 ? col.rowSpan : undefined, scope: colScope },
                    react_1.default.createElement("span", { className: `ts-datatable-header-cell ${isSortable ? 'sortable' : ''}`.trim(), onClick: isSortable ? onClick : undefined, onMouseDown: isSortable ? (e) => { if (e.shiftKey) {
                            e.preventDefault();
                        } } : undefined },
                        react_1.default.createElement("span", { className: 'ts-datatable-header-content' }, col.header),
                        react_1.default.createElement(sortable_1.HeaderSort, { column: col, sort: sort })))));
        })))),
        props.enableColumnSearch && react_1.default.createElement(column_search_1.ColumnSearch, { hasValidPreMDRColumn: hasValidPreMDRColumn, hasDetailRenderer: hasDetailRenderer })));
};
exports.TableHeader = TableHeader;
