"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HeaderSort = void 0;
const react_1 = __importDefault(require("react"));
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faSort_1 = require("@fortawesome/free-solid-svg-icons/faSort");
const faSortUp_1 = require("@fortawesome/free-solid-svg-icons/faSortUp");
const faSortDown_1 = require("@fortawesome/free-solid-svg-icons/faSortDown");
const HeaderSort = function HeaderSort(props) {
    const { column, sort } = props;
    if (!column.sortable || column.colSpan > 1 || !column.name)
        return null;
    if (sort) {
        if (sort.direction === 'asc')
            return react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSortUp_1.faSortUp, className: 'sort-icon' });
        return react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSortDown_1.faSortDown, className: 'sort-icon' });
    }
    return react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { icon: faSort_1.faSort, style: { opacity: .3 }, className: 'sort-icon' });
};
exports.HeaderSort = HeaderSort;
