"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableGroup = void 0;
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const react_1 = __importStar(require("react"));
const contexts_1 = require("./contexts");
const table_row_1 = require("./table-row");
const types_1 = require("./types");
const faChevronRight_1 = require("@fortawesome/free-solid-svg-icons/faChevronRight");
const faChevronDown_1 = require("@fortawesome/free-solid-svg-icons/faChevronDown");
const TableGroup = function TableGroup({ group, canEditRow }) {
    var _a;
    const { actualColumns: columns, canSelectRows, DetailRow, groupsExpandedByDefault, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const { collapsedState, setExpanded } = (0, react_1.useContext)(contexts_1.GroupCollapseContext);
    const isExpanded = (_a = collapsedState[group.key]) !== null && _a !== void 0 ? _a : groupsExpandedByDefault;
    let columnCount = columns.reduce((v, c) => (c.isVisible && !c.isGrouped) ? v + 1 : v, 0);
    let hasDetailRenderer = (!!DetailRow);
    if (hasDetailRenderer)
        columnCount++;
    if (canSelectRows)
        columnCount++;
    let groupColumn = columns.find(c => c.name === group.column);
    let groupStyle = { '--indent': group.level - 1 };
    let rendered = null;
    if (typeof (groupColumn === null || groupColumn === void 0 ? void 0 : groupColumn.renderGroup) === 'function') {
        rendered = groupColumn.renderGroup(group.value, group, groupColumn);
    }
    else if (typeof (groupColumn === null || groupColumn === void 0 ? void 0 : groupColumn.render) === 'function') {
        rendered = groupColumn.render(group.value, group.firstRow, groupColumn, -1);
    }
    else {
        rendered = group.value;
    }
    return react_1.default.createElement(react_1.default.Fragment, null,
        !!groupColumn && react_1.default.createElement("tr", { style: groupStyle },
            react_1.default.createElement("th", { className: 'row-group' },
                react_1.default.createElement("div", { className: 'row-group-container' },
                    react_1.default.createElement("button", { type: 'button', className: 'mdr-button', onClick: () => setExpanded(group.key, !isExpanded) },
                        react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: isExpanded ? faChevronDown_1.faChevronDown : faChevronRight_1.faChevronRight })),
                    react_1.default.createElement("div", { className: 'group-column-name' }, groupColumn.header),
                    react_1.default.createElement("div", { className: 'group-column-value' }, rendered))),
            columnCount > 1 && react_1.default.createElement("th", { colSpan: columnCount - 1 })),
        isExpanded && react_1.default.createElement(react_1.default.Fragment, null,
            (0, types_1.isDataGroupArray)(group.children) && react_1.default.createElement(react_1.default.Fragment, null, group.children.map(g => react_1.default.createElement(TableGroup, { key: g.key, group: g, canEditRow: canEditRow }))),
            (0, types_1.isDataRowArray)(group.children) && react_1.default.createElement(react_1.default.Fragment, null, group.children.map(row => react_1.default.createElement(table_row_1.TableRow, { key: row.key, rowIndex: row.rowIndex, row: row.row, canEditRow: canEditRow, group: group })))));
};
exports.TableGroup = TableGroup;
