"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableRow = void 0;
const react_1 = __importStar(require("react"));
const contexts_1 = require("./contexts");
const getRowKey_1 = require("../../utils/getRowKey");
const editors_1 = require("./editors");
const react_fontawesome_1 = require("@fortawesome/react-fontawesome");
const faChevronRight_1 = require("@fortawesome/free-solid-svg-icons/faChevronRight");
const faChevronDown_1 = require("@fortawesome/free-solid-svg-icons/faChevronDown");
const row_selector_1 = require("../row-selector");
const types_1 = require("./types");
const isEqual_1 = __importDefault(require("lodash/isEqual"));
const TableRow = function TableRow(_a) {
    var _b, _c, _d, _e, _f, _g;
    var { row, group } = _a, props = __rest(_a, ["row", "group"]);
    const [isExpanded, setExpanded] = (0, react_1.useState)(false);
    const { actualColumns: columns, DetailRow, canRowShowDetail, canSelectRows, getTableRowProps, getTableCellProps, preMDRColumn, } = (0, react_1.useContext)(contexts_1.ColumnContext);
    const [{ isEditing, editMode, }] = (0, contexts_1.useTableSelector)(c => ({
        isEditing: c.isEditing,
        editMode: c.editMode,
    }), isEqual_1.default);
    let canEditRow = (isEditing || editMode !== 'default');
    if (canEditRow && typeof props.canEditRow === 'function')
        canEditRow = props.canEditRow(row);
    let columnCount = 0;
    let hasDetailRenderer = (!!DetailRow);
    let detailRowAvailable = hasDetailRenderer;
    if (detailRowAvailable && typeof canRowShowDetail === 'function')
        detailRowAvailable = canRowShowDetail(row);
    const DetailRowRenderer = DetailRow !== null && DetailRow !== void 0 ? DetailRow : FakeDetailRow;
    let rowStyle = { '--indent': (_b = group === null || group === void 0 ? void 0 : group.level) !== null && _b !== void 0 ? _b : 0 };
    let rowProps = {};
    if (getTableRowProps && typeof getTableRowProps === 'function') {
        rowProps = (_c = getTableRowProps(row)) !== null && _c !== void 0 ? _c : {};
        if (rowProps.style) {
            rowProps.style = Object.assign(Object.assign({}, rowProps.style), rowStyle);
        }
        else {
            rowProps.style = rowStyle;
        }
    }
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("tr", Object.assign({}, rowProps),
            (0, types_1.isValidPreMDRColumn)(preMDRColumn) && react_1.default.createElement("td", { key: 'premdr', className: `fixed fixed-left premdr-col ${(_d = preMDRColumn.className) !== null && _d !== void 0 ? _d : ''}`.trim() },
                react_1.default.createElement("div", { className: 'premdr-col-content' }, (_f = (_e = preMDRColumn.render) === null || _e === void 0 ? void 0 : _e.call(preMDRColumn, null, row, preMDRColumn, props.rowIndex)) !== null && _f !== void 0 ? _f : '')),
            hasDetailRenderer && react_1.default.createElement("td", { key: `mdr`, className: 'fixed fixed-left mdr-control' }, detailRowAvailable && react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("button", { type: 'button', className: 'mdr-button', onClick: () => setExpanded(v => !v) },
                    react_1.default.createElement(react_fontawesome_1.FontAwesomeIcon, { fixedWidth: true, icon: isExpanded ? faChevronDown_1.faChevronDown : faChevronRight_1.faChevronRight })))),
            canSelectRows && react_1.default.createElement("td", { key: `sel`, className: 'fixed fixed-left row-selector' },
                react_1.default.createElement(row_selector_1.RowSelector, { row: row, rowIndex: props.rowIndex })),
            columns.map((col, colIdx) => {
                var _a, _b;
                if (!col.isVisible || col.isGrouped)
                    return null;
                columnCount++;
                let value = (0, getRowKey_1.getRowValue)(row, col);
                let rendered = null;
                if ((isEditing || editMode !== 'default') && col.editor) {
                    let canEdit = canEditRow;
                    if (canEditRow && typeof col.canEdit === 'function')
                        canEdit = col.canEdit(row, col);
                    if (canEdit) {
                        rendered = react_1.default.createElement(editors_1.CellEditor, { column: col, value: value, row: row, rowIndex: props.rowIndex });
                        if (col.EditorWrapper) {
                            let renderValue = typeof col.render !== 'undefined'
                                ? col.render(value, row, col, props.rowIndex)
                                : value;
                            const Wrapper = col.EditorWrapper;
                            rendered = react_1.default.createElement(Wrapper, { value: renderValue, rawValue: value, row: row, column: col }, rendered);
                        }
                    }
                }
                if (rendered === null) {
                    rendered = typeof col.render !== 'undefined'
                        ? col.render(value, row, col, props.rowIndex)
                        : value;
                }
                let classNames = [(_a = col.className) !== null && _a !== void 0 ? _a : '', col.fixed ? `fixed fixed-${col.fixed}` : ''];
                let cellProps = {};
                if (getTableCellProps && typeof getTableCellProps === 'function') {
                    cellProps = (_b = getTableCellProps(value, row, col)) !== null && _b !== void 0 ? _b : {};
                    if (cellProps.className) {
                        classNames.push(cellProps.className);
                    }
                    classNames = classNames.filter(s => !!s);
                }
                cellProps.className = classNames.join(' ').trim();
                return react_1.default.createElement("td", Object.assign({}, cellProps, { key: colIdx }), rendered);
            })),
        isExpanded && !!DetailRow && react_1.default.createElement("tr", null,
            (0, types_1.isValidPreMDRColumn)(preMDRColumn) && react_1.default.createElement("td", { key: 'premdr', className: `fixed fixed-left premdr-col ${(_g = preMDRColumn.className) !== null && _g !== void 0 ? _g : ''}`.trim() }),
            hasDetailRenderer && react_1.default.createElement("td", { className: 'fixed fixed-left mdr-control' }),
            canSelectRows && react_1.default.createElement("td", { className: 'fixed fixed-left row-selector' }),
            react_1.default.createElement("td", { colSpan: columnCount },
                react_1.default.createElement(DetailRowRenderer, { parentRow: row }))));
};
exports.TableRow = TableRow;
const FakeDetailRow = () => {
    return react_1.default.createElement(react_1.default.Fragment, null);
};
