"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isFilterItem = exports.isFilterGroup = exports.isCustomFilter = exports.QuickOperatorLabels = exports.OperatorLabels = exports.BooleanOperators = exports.NumberOperators = exports.StringOperators = exports.isValidPreMDRColumn = exports.isDataRowArray = exports.isDataGroupArray = exports.isDataRow = exports.isDataGroup = void 0;
function isDataGroup(value) {
    if (!value)
        return false;
    return (typeof value.column === 'string');
}
exports.isDataGroup = isDataGroup;
function isDataRow(value) {
    if (!value)
        return false;
    return (typeof value.column === 'undefined');
}
exports.isDataRow = isDataRow;
function isDataGroupArray(value) {
    if (!(value === null || value === void 0 ? void 0 : value.length))
        return false;
    return (typeof value[0].column === 'string');
}
exports.isDataGroupArray = isDataGroupArray;
function isDataRowArray(value) {
    if (!(value === null || value === void 0 ? void 0 : value.length))
        return false;
    return (typeof value[0].column === 'undefined');
}
exports.isDataRowArray = isDataRowArray;
function isValidPreMDRColumn(col) {
    return (!!col && typeof col.render === 'function' && typeof col.preMDRColumnWidth === 'number' && !Number.isNaN(col.preMDRColumnWidth) && Number.isFinite(col.preMDRColumnWidth));
}
exports.isValidPreMDRColumn = isValidPreMDRColumn;
const SingleStringOperators = ['eq', 'ieq', 'neq', 'gt', 'gte', 'lt', 'lte', 'con', 'ncon', 'beg', 'end', 'nul', 'nnul'];
exports.StringOperators = [...SingleStringOperators, 'bet', 'nbet', 'any', 'none'];
exports.NumberOperators = ['eq', 'neq', 'gt', 'gte', 'lt', 'lte', 'bet', 'nbet', 'nul', 'nnul', 'any', 'none'];
exports.BooleanOperators = ['eq', 'neq', 'nul', 'nnul'];
exports.OperatorLabels = {
    'eq': 'Equals',
    'ieq': 'Case-insensitive Equals',
    'neq': 'Does not equal',
    'gt': 'Is greater than',
    'gte': 'Is greater than or equal to',
    'lt': 'Is less than',
    'lte': 'Is less than or equal to',
    'bet': 'Is Between',
    'nbet': 'Is not between',
    'con': 'Contains',
    'ncon': 'Does not contain',
    'beg': 'Begins with',
    'end': 'Ends with',
    'nul': 'Is not set',
    'nnul': 'Is set',
    'any': 'Is any of',
    'none': 'Is none of',
};
exports.QuickOperatorLabels = {
    'eq': '=',
    'ieq': '≈',
    'neq': '≠',
    'gt': '>',
    'gte': '≥',
    'lt': '<',
    'lte': '≤',
    'bet': 'between',
    'nbet': 'not between',
    'con': 'contains',
    'ncon': 'not contains',
    'beg': 'starts with',
    'end': 'ends with',
    'nul': 'is not set',
    'nnul': 'is set',
    'any': 'is in',
    'none': 'is not in',
};
function isCustomFilter(value) {
    return (value === null || value === void 0 ? void 0 : value.type) === 'custom';
}
exports.isCustomFilter = isCustomFilter;
function isFilterGroup(value) {
    if (!value)
        return false;
    return (typeof value.groupOperator === 'string');
}
exports.isFilterGroup = isFilterGroup;
function isFilterItem(value) {
    if (!value)
        return false;
    return (typeof value.column === 'string');
}
exports.isFilterItem = isFilterItem;
