"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolve = void 0;
function resolve(fn, defaultValue) {
    if (typeof fn === 'undefined') {
        if (typeof defaultValue === 'undefined')
            throw new Error(`Unable to resolve value - no value passed, and no default specified`);
        return defaultValue;
    }
    if (isSyncFn(fn))
        return fn();
    return fn;
}
exports.resolve = resolve;
function isSyncFn(fn) {
    return (typeof fn === 'function');
}
