"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.closest = void 0;
function closest(el, selector) {
    if (!el)
        return null;
    if (typeof el.closest === 'function')
        return el.closest(selector);
    if (typeof el.matches === 'function') {
        let e = el;
        do {
            if (e.matches(selector))
                return e;
            e = e.parentElement || e.parentNode;
        } while (e !== null && e.nodeType === 1);
        return null;
    }
    throw new Error('"closest" not available');
}
exports.closest = closest;
