"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.notEmpty = exports.arrayCompare = exports.simpleCompare = exports.deepCompare = void 0;
const isEqual_1 = __importDefault(require("lodash/isEqual"));
function deepCompare(a, b) {
    return (0, isEqual_1.default)(a, b);
}
exports.deepCompare = deepCompare;
function simpleCompare(a, b) {
    if (a.length !== b.length)
        return false;
    return b.every((x, i) => a[i] === x);
}
exports.simpleCompare = simpleCompare;
function arrayCompare(a, b) {
    if (a.length !== b.length)
        return false;
    return b.every((x, i) => simpleCompare(a[i], x));
}
exports.arrayCompare = arrayCompare;
function notEmpty(value) {
    return value !== null && typeof value !== 'undefined';
}
exports.notEmpty = notEmpty;
