"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.firstFocusable = void 0;
const focusableItems = ['button', '[href]', 'input', 'select', 'textarea', '[tabindex]'].map(f => `${f}:not([tabindex="-1"]):not([data-noautofocus])`).join(', ');
function firstFocusable(el) {
    let autofocus = el.querySelector('[autofocus], .autofocus');
    if (autofocus)
        return autofocus;
    let focusable = el.querySelector(focusableItems);
    if (!focusable)
        return null;
    return focusable;
}
exports.firstFocusable = firstFocusable;
