"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getGroupKey = exports.getGroupKeys = void 0;
const getRowKey_1 = require("./getRowKey");
function getGroupKeys(row, groupByOrder, columns) {
    let groupKeys = [];
    for (let i = 0; i < groupByOrder.length; i++) {
        let col = columns.find(c => c.name === groupByOrder[i].column);
        if (!col) {
            groupKeys.push({ column: groupByOrder[i].column, value: undefined });
        }
        else {
            let value = (0, getRowKey_1.getRowValue)(row, col);
            groupKeys.push({ column: groupByOrder[i].column, value });
        }
    }
    return groupKeys;
}
exports.getGroupKeys = getGroupKeys;
const NUL = String.fromCharCode(0);
const UNIT_SEP = String.fromCharCode(31);
function getGroupKey(keys) {
    return keys.map(k => {
        let value = JSON.stringify(k.value, (a, b) => b === undefined ? NUL : b);
        return `${k.column}:${value}`;
    })
        .join(UNIT_SEP);
}
exports.getGroupKey = getGroupKey;
