"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getRowValue = exports.getRowKey = void 0;
const get_1 = __importDefault(require("lodash/get"));
function getRowKey(row, rowIdx, columns, fn) {
    if (typeof fn === 'function')
        return fn(row);
    let column = columns.find(c => c.isPrimaryKey);
    if (column) {
        return getRowValue(row, column);
    }
    return rowIdx;
}
exports.getRowKey = getRowKey;
function getRowValue(row, col) {
    let value = typeof col.accessor !== 'undefined'
        ? (0, get_1.default)(row, col.accessor)
        : col.getValue(row, col);
    return value;
}
exports.getRowValue = getRowValue;
