"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getScrollParent = void 0;
function getScrollParent(el, includeHidden = false) {
    let style = window.getComputedStyle(el);
    let excludeStaticParent = style.position === "absolute";
    let overflowRegex = includeHidden ? /(auto|scroll|hidden)/ : /(auto|scroll)/;
    if (style.position === "fixed")
        return document.body;
    for (let parent = el; (parent = parent.parentElement);) {
        style = getComputedStyle(parent);
        if (excludeStaticParent && style.position === "static") {
            continue;
        }
        if (overflowRegex.test(style.overflow + style.overflowY + style.overflowX)) {
            return parent;
        }
    }
    return document.body;
}
exports.getScrollParent = getScrollParent;
