"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.doSetColumnSort = void 0;
function doSetColumnSort(setColumnSort, newSort, shiftKey, multiColumnSorts) {
    if (multiColumnSorts && shiftKey) {
        setColumnSort(state => {
            const sort = state.sort.find(s => s.column === newSort.column);
            if (sort) {
                return {
                    sort: state.sort.map(s => {
                        if (sort.column === s.column)
                            return newSort;
                        return s;
                    })
                };
            }
            else {
                return {
                    sort: [
                        ...state.sort,
                        newSort,
                    ]
                };
            }
        });
    }
    else {
        setColumnSort({ sort: [newSort] });
    }
}
exports.doSetColumnSort = doSetColumnSort;
