"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveLocalState = exports.getLocalState = void 0;
function getLocalState(key) {
    if (typeof window === 'undefined' || !window.localStorage)
        return null;
    try {
        let state = window.localStorage.getItem(key);
        if (state === null)
            return null;
        return JSON.parse(state);
    }
    catch (_a) {
        return null;
    }
}
exports.getLocalState = getLocalState;
function saveLocalState(key, value) {
    if (typeof window === 'undefined' || !window.localStorage)
        return;
    try {
        window.localStorage.setItem(key, JSON.stringify(value));
    }
    catch (_a) { }
}
exports.saveLocalState = saveLocalState;
