import { DataColumnProp, DataColumn, ColumnVisibilityStorage, ColumnSort } from '../components/table/types';
/**
 * Transform columns from the table prop to an internal form.
 * Still hierarchical so it can better determine which top level columns to hide/show.
 *
 * @param tableId Table Identifier to help keep some keys unique.
 * @param propColumns The list of columns from the table props.
 * @param parentKey Internal use only for hierarchical data.
 */
export declare function transformColumns<T>(tableId: string, propColumns: Partial<DataColumnProp<T>>[], columnVisibility: ColumnVisibilityStorage, groupBy: ColumnSort[], parentKey?: string): DataColumn<T>[];
export declare function getFlattenedColumns<T>(visibleColumns: DataColumn<T>[], flattened?: DataColumn<T>[]): DataColumn<T>[];
export declare function generateHeaderRows<T>(columns: DataColumn<T>[], columnOrder: string[]): DataColumn<T>[][];
