"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDeepEffect = void 0;
const react_1 = require("react");
const comparators_1 = require("./comparators");
function useDeepEffect(fn, depList) {
    let localRef = (0, react_1.useRef)({ init: false, effectDep: false });
    if (!localRef.current.init || !(0, comparators_1.deepCompare)(depList, localRef.current.depList)) {
        localRef.current = {
            init: true,
            effectDep: !localRef.current.effectDep,
            depList,
        };
    }
    (0, react_1.useEffect)(fn, [localRef.current.effectDep]);
}
exports.useDeepEffect = useDeepEffect;
