"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useDeepMemo = void 0;
const react_1 = require("react");
const comparators_1 = require("./comparators");
function useDeepMemo(fn, depList) {
    let localRef = (0, react_1.useRef)({ init: false });
    if (!localRef.current.init || !(0, comparators_1.deepCompare)(depList, localRef.current.depList)) {
        localRef.current = {
            init: true,
            value: fn(),
            depList,
        };
    }
    return localRef.current.value;
}
exports.useDeepMemo = useDeepMemo;
