"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useEventListener = void 0;
const react_1 = require("react");
const useEventListener = (target, type, listener, ...options) => {
    (0, react_1.useEffect)(() => {
        const currentTarget = isRef(target)
            ? target.current
            : target;
        if (currentTarget)
            currentTarget.addEventListener(type, listener, ...options);
        return () => {
            if (currentTarget)
                currentTarget.removeEventListener(type, listener, ...options);
        };
    }, [target, type, listener, options]);
};
exports.useEventListener = useEventListener;
function isRef(target) {
    return Object.prototype.hasOwnProperty.call(target, 'current');
}
