"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useParsedQs = void 0;
const use_querystate_1 = require("@borvik/use-querystate");
const useDerivedState_1 = require("./useDerivedState");
const react_1 = require("react");
function useParsedQs(initialState, parse, encode, options) {
    const [qsInitialState] = (0, useDerivedState_1.useDeepDerivedState)(() => encode(initialState), [initialState]);
    const [localState, setLocalState] = (0, use_querystate_1.useQueryState)(qsInitialState, options);
    const [actualState] = (0, useDerivedState_1.useDeepDerivedState)(() => parse(localState), [localState]);
    const publicSetState = (0, react_1.useCallback)((newState) => {
        setLocalState(() => {
            let newActualState = typeof newState === 'function'
                ? newState(actualState)
                : newState;
            let newQsState = encode(newActualState);
            return newQsState;
        });
    }, [actualState, encode, setLocalState]);
    (0, react_1.useDebugValue)(actualState);
    return [actualState, publicSetState];
}
exports.useParsedQs = useParsedQs;
